/* Main/Initialize Module   "cmninit.c"     -*- C -*-  */

/*
#S#
#
# This Program is part of SV (Shelx-output Viewer)
# Copyright (C) 1991-1998 Takashi Nemoto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details. (File "COPYING")
#
#    Note!: General Public Licence is copyrighted by the Free Software 
#           Foundation,  but this code is copyrighted by me.
#
#    Send bugs and comments to tnemoto@eels.kuicr.kyoto-u.ac.jp
#
#E#
*/

#define __cmninit_c__
#define __version_c_proc__
#define __message_c_proc__
#define __readf_c_proc__
#define __shelplot_c_proc__
#define __shelview_c_proc__
#define __cmd_c_proc__
#define __bond_c_proc__
#define __stack_c_proc__
#define __subs_c_proc__
#define __file_c_proc__
#define __svx_c_proc__
#define __filetype_c_proc__
#ifdef UNIX
#define __xtmain_c_proc__
#endif

#define __string_proc__
#include <math.h>
#include <signal.h>
#include "def.h"
SV_Function int CommonInitialize(void) 
{
  ReadConfig();
  log_fp=NULL;
  return 1;
}


/**** Each Crystal ****/
SV_Function int OpenCrystalInitialize()
{
#ifdef IGraph
  n_iarcs=0;
  n_ilines=0;
  n_irvmts=0;
  n_iorgs=0;
#endif
  MAX_ATOM=MAX_SYMATOM=ATOM_BLOCK_SIZE;
  MAX_BOND=BOND_BLOCK_SIZE;
  orgAtom=Malloc(MAX_ATOM*sizeof(ATOM_PARAM));
  BOND=Malloc(MAX_BOND*sizeof(BOND_PARAM));
  SAT=Malloc(MAX_SYMATOM*sizeof(S_AT));
  if (orgAtom==NULL) {PutMessage1("Can not alloc memory (orgAtom)");Exit(1);}
  if (BOND==NULL) {PutMessage1("Can not alloc memory (BOND)");Exit(1);}
  if (SAT==NULL) {PutMessage1("Can not alloc memory (SAT)");Exit(1);}
  init();
  strcpy(Title,"SVX");
  readfile2();
  log_fp=ffopen("sv.log","w");
  if (log_fp==NULL) {
    PutMessage1("Can not open sv.log");
    return 0;
  }
  if (BOND[0].atm[0]<0) { 
    AppendCommandQueue("makebond auto");
  };
/*
  if (BOND[0].atm[0]<0) { 
    cmd_c=1;
    setpara(0,"AUTO");
    global_flag|=GLOBALFLAG_NOTREFRESH;
    make_bond();
    global_flag&=~GLOBALFLAG_NOTREFRESH;
  };
*/
/*  AppendCommandQueue("build #0");*/
  return 1;
}

SV_Function int CloseCrystalInitialize()
{
    if (log_fp!=NULL)fclose(log_fp);
    log_fp=NULL;
    Free(orgAtom);
    Free(BOND);
    Free(SAT);
    return 1;
}

SV_Function void init(void)
{
  int i,j;
  for (i=0;i<MAX_SYMATOM;i++) SAT[i].view_flag=0;
  for (i=0;i<3;i++) for (j=0;j<3;j++) VMT[i][j]=(i==j)?1:0;
  shift[0]=shift[1]=0;
  sshift[0]=sshift[1]=0;
  vscale=1;
  global_flag=GLOBALFLAG_LABEL | GLOBALFLAG_TMP_LABEL | GLOBALFLAG_GC;
  ZVIEW=0;
#ifdef SLOW_MACHINE
/* Too Slow!! */
  SEARCH_MIN=-1;
  SEARCH_MAX=2;
#else
  SEARCH_MIN=-2;
  SEARCH_MAX=3;
#endif
  disp_str[0][0]=0;
  rot_step=1;

  atom_stack_top= atom_stack_top_bak=-1;
  atom_stack=atom_stack_bak=NULL;
  MAX_ATOM_STACK=MAX_ATOM_STACK_BAK=-1;

  LATT=-1;
  n_sfac=0;

}

SV_Function void finish(void)
{
/*
        shelxout();
        fdatout();
*/
}

