/* file type detection module "filetype.c"  -*- C -*- */
#define __filetype_c__
#define __string_proc__
#define __config_c_proc__
#define __subs_c_proc__
#include "def.h"
#ifdef __MSWIN__
#include "windows.h"
#endif
#include <ctype.h>

SV_Function int SplitLine(char **SplitPoint,char *cc,char *cc2,char *str,int MaxSplit) 
{
/* cc and cc2 are delimiter. cc : remove, cc2 : keep */
  int nSplit;
  int p0,p1;
  int ch;
  nSplit=1;
  SplitPoint[0]=SplitTempStr;
  p0=0;
  p1=0;
  while((ch=str[p0++])!=0 && nSplit<MaxSplit) {
    SplitTempStr[p1++]=ch;
    if (strchr(cc,ch)!=NULL) {
      SplitTempStr[p1-1]=0;
      SplitPoint[nSplit++]=SplitTempStr+p1;
    } else if (strchr(cc2,ch)!=NULL) {
      if (p1>=2 && SplitTempStr[p1-2]!=0) {
	SplitTempStr[p1]=ch;
	SplitTempStr[p1-1]=0;
	SplitPoint[nSplit++]=SplitTempStr+p1;
	p1++;
      }
    }
  }
  SplitTempStr[p1++]=ch;
  if (ch!=0) {
    while((ch=str[p0++])!=0) {
      SplitTempStr[p1++]=ch;
    }
    SplitTempStr[p1]=0;
  }
#if 0
  {
    int i;
    fprintf(stderr,"X%sX%sX%sX\n",str,cc,cc2);
    for(i=0;i<nSplit;i++){
      fprintf(stderr,"Y%sY\n",SplitPoint[i]);
    }
  }
#endif
  return nSplit;
}

SV_Function int DecodeLine(char *src, char *dest,int MaxChar) 
{
  *dest=0;
  while(*src!=0) {
    if (*src == '$') {
      char Buf0[cBufSize];
      char *s0;
      int i;
      i=0;
      s0=src+1;
      while(isalpha(*s0)) {
        Buf0[i++]=*(s0++);
      }
      Buf0[i]=0;
      strcat(dest,getenv(Buf0));
      src=s0-1;
    } else if (*src == '&') {
      if (src[1]=='A') {
        strcat(dest,"\x01");
      } else if (src[1]=='a') {
        strcat(dest,"\x03");
      } else if (src[1]=='0') {
        strcat(dest,"\x02");
      } 
      src++;
    } else if (*src == '?') {
      strcat(dest,"\x04");
    } else  {
      int l=strlen(dest);
      dest[l]=*src;
      dest[l+1]=0;
    }
    src++;
  }
  return 1;
}

SV_Function int Chop(char *str) 
{
  int len;
  if (str==NULL) return 0;
  len=strlen(str);
  while(len>0 && (str[len-1]=='\r' || str[len-1]=='\n')) {
    str[--len]=0;
  }
  return 1;
}

SV_Function int PackLine(char *str) 
{
  char *dest,*dest0;
  int IsQuoted;
  char QuoteType;
  dest0=dest=str;
  while(isspace(*str)) {
    str++;
  }
  IsQuoted=0;
  QuoteType=0;
  while(*str != 0) {
    if ((!IsQuoted) && (*str == '\'' || *str == '"')) {
      IsQuoted=TRUE;
    } else if (IsQuoted && (*str==QuoteType)) {
      QuoteType=0;
      IsQuoted=FALSE;
    }
    if ((!IsQuoted) && isspace(*str) ) {
      *(dest++)=' ';
      while(isspace(*str)) {
        str++;
      }
    } else {
      *(dest++)=*(str++);
    }
  }
  *(dest--)=0;
  if (dest>=dest0 && *dest==' ') *dest=0;
  return 1;
}

SV_Function int PackLine2(char *str) 
{
  char *dest,*dest0;
  dest=dest0=str;
  while(!isalpha(*str) && *str!=0) {
    str++;
  }
  while(*str != 0) {
    if (!isalpha(*str)) {
      *(dest++)=' ';
      while(!isalpha(*str) && *str!=0) {
        str++;
      }
    } else {
      *(dest++)=*(str++);
    }
  }
  *(dest--)=0;
  if (dest>=dest0 && *dest==' ') *dest=0;
  return 1;
}

SV_Function int ToLowerLine(char *text) 
{
  while(*text != 0) {
    if (isalpha(*text)) *text=tolower(*text);
    text++;
  }
  return 1;
}

SV_Function int ToUpperLine(char *text) 
{
  while(*text != 0) {
    if (isalpha(*text)) *text=toupper(*text);
    text++;
  }
  return 1;
}

SV_Function int FindLine(char *text,char *SearchString) 
{
  int i,j;
  int TextLength,StringLength;
  int Found;
  StringLength=strlen(SearchString);
  TextLength=strlen(text)-StringLength;
  for(i=0;i<=TextLength;i++){
    Found=1;
    for(j=0;j<StringLength;j++){
      int c;
      c=SearchString[j];
      if (c>=32) {
        if (c!=text[i+j]) {
          Found=0;
          break;
        }
      } else {
        if (! (
               ((c & 1) && isalpha(text[i+j])) || 
               ((c & 2) && isdigit(text[i+j])) ||
               (c & 4)
            )) {
          Found=0;
          break;
        }
      }
    }
    if (Found!=0) {
      return i;
    }
  }
  return -1;
}

SV_Function int ReplaceLine(char *src,char *dest,char *org,char *replace)
{
  int FindSpot;
  *dest=0;
  while((FindSpot=FindLine(src,org))>=0) {
    strncat(dest,src,FindSpot);
    src+=strlen(org)+FindSpot;
    strcat(dest,replace);
  }
  strcat(dest,src);
  return 1;
}

SV_Function char *GetPathFromFileName(char *FileName) 
{
  int l;
  char *Path;
  l=strlen(FileName);
  Path=Malloc(l>2?l+1:3);
  strcpy(Path,FileName);
  l--;
  if (l<0) return FileName;
  while(l>=0) {
    if (FileName[l]=='/' || FileName[l]=='\\' || FileName[l]==':') {
      sprintf(FileName,"%s",Path+l+1);
      Path[l+1]=0;
      break;
    }
    l--;
  }
  if (l<0) {
    Path[0]='.';	
    Path[1]=FileDelimitor;
    Path[2]=0;
  }
  
  return Path;    
}

SV_Variable int MAX_FILETYPE;
SV_Variable int *FileTypeCheckList;
SV_Variable FileTypeCheck_T *FileTypeBlock;
SV_Variable int nFileType;

SV_Variable int MAX_STRING;
SV_Variable char *StringBlock;
SV_Variable int nStringLength;

SV_Variable int MAX_DEFAULTFILE;
SV_Variable int *DefaultFileList;
SV_Variable int nDefaultFile;

SV_Variable int nInteger;
SV_Variable int MAX_INTEGER;
SV_Variable int *IntegerBlock;

SV_Variable char **SplitPoint;
SV_Variable char SplitTempStr[cBufSize*2];
SV_Variable int nSplitPoint;

SV_LocalFunction FILE *OpenConfigFile(void) 
{
/* $SVCONFIG $HOME/svx.ini $HOME/.svx $SVBINDIR/svx.ini */
  FILE *fp;
  char *f1;
  char FileBuffer[cBufSize];
  fp=NULL;
  /* Check $SVCONFIG */
  f1=getenv("SVCONFIG");
  if (f1 != NULL) {
    strcpy(f1,FileBuffer);
    fp=fopen(FileBuffer,"r");
  }
  /* Check $HOME/svx.ini, $HOME/.svx */
  if (fp==NULL) {
    f1=getenv("HOME");
    if (f1!=NULL) {
        fp=fopen(filename(f1,"svx.ini"),"r");
#ifdef UNIX
        if (fp==NULL) {
                fp=fopen(filename(f1,".svx"),"r");
        }
#endif
    }
  }
  if (fp==NULL) {
    f1=getenv("SVBINDIR");
    if (f1!=NULL) {
        fp=fopen(filename(f1,"/svx.ini"),"r");
    }
  }

#ifdef SVBINDIR
  if (fp==NULL) {
    fp=fopen(filename(SVBINDIR,"/svx.ini"),"r");
  }
#ifdef UNIX
  if (fp==NULL) {
    fp=fopen(filename(SVBINDIR,"/.svx"),"r");
  }
#endif
#endif

#ifdef __MSWIN__
  if (fp==NULL) {
    char f2[cBufSize];
    if (0!=GetModuleFileName(NULL,f2,cBufSize)) {
#ifdef DEBUG
      PutMessage1(f2);
#endif
        fp=fopen(filename(f2,"svx.ini"),"r");
    }
  }
  if (fp==NULL) {
    char f2[cBufSize];
    if (0!=GetWindowsDirectory(f2,cBufSize)) {
        fp=fopen(filename(f2,"svx.ini"),"r");
    }
  }
#endif
  if (fp==NULL) {
    fp=fopen("svx.ini","r");
  }
  if (fp==NULL) {
    return NULL;
  }
  return fp;
}

SV_LocalFunction int newFileType(void) 
{
  if (MAX_FILETYPE<=nFileType+1) {
    int x;
    x=MAX_FILETYPE;
    FileTypeBlock=Realloc(FileTypeBlock,&MAX_FILETYPE,SVX_BLOCK_SIZE,
                          sizeof(FileTypeCheck_T));
    FileTypeCheckList=Realloc(FileTypeCheckList,&x,SVX_BLOCK_SIZE,sizeof(int));
  }
  return nFileType++;
}

SV_LocalFunction int newString(char *string) 
{
  int size;
  size=strlen(string)+1;
  if (MAX_STRING<=nStringLength+size) {
    int I;
    I=STRING_BLOCK_SIZE;
    while(MAX_STRING+I<=nStringLength+size) {
      I+=STRING_BLOCK_SIZE;
    }
    StringBlock=Realloc(StringBlock,&MAX_STRING,I,1);
  }
  strcpy(StringBlock+nStringLength,string);
  nStringLength+=size;
  return nStringLength-size;
}

SV_LocalFunction int newDefaultFile(char *fileName)
{
  if (MAX_DEFAULTFILE<=nDefaultFile+1) {
    DefaultFileList=(int *)Realloc(DefaultFileList,&MAX_DEFAULTFILE,
                                   SVX_BLOCK_SIZE,sizeof(int));
  }
  return (DefaultFileList[nDefaultFile++]=newString(fileName));
}

SV_LocalFunction int newInteger(int i)
{
  if (MAX_INTEGER<=nInteger+i) {
    int I=SVX_BLOCK_SIZE;
    while(MAX_INTEGER+I<=nInteger+i) {
      I+=SVX_BLOCK_SIZE;
    }
    IntegerBlock=(int *)Realloc(IntegerBlock,&MAX_INTEGER,I,sizeof(int));
  }
  nInteger+=i;
  return nInteger-i;
}

SV_Function int ReadConfig(void) 
{
  FILE *fp;
  char FileBuffer[cBufSize],FileBuffer2[cBufSize];
  int LineNo;
  int configLine=0;

  nStringLength=0;
  MAX_STRING=0;
  StringBlock=NULL;

  nInteger=0;
  MAX_INTEGER=0;
  IntegerBlock=NULL;

  nDefaultFile=0;
  MAX_DEFAULTFILE=0;
  DefaultFileList=NULL;
  
  nFileType=0;
  MAX_FILETYPE=0;
  FileTypeCheckList=NULL;
  FileTypeBlock=NULL;
  
  SplitPoint=(char **)Malloc(sizeof(char *)*cBufSize);

  fp=OpenConfigFile();
  if (fp==NULL) {
      PutMessage1("Can't open configuration file! Default Values are used.");
  }
  LineNo=0;
  for(;;){
    if (fp==NULL) {
      if (configData[configLine]==NULL) break;
      strncpy(FileBuffer,configData[configLine++],cBufSize);
/*      fprintf(stderr,"XX %s XX\n",FileBuffer);*/
    } else {
      if (fgets(FileBuffer,cBufSize,fp)==NULL)  break;
    }
    LineNo++;
    if (FileBuffer[0]=='#') continue;
    Chop(FileBuffer);
    PackLine(FileBuffer);
    DecodeLine(FileBuffer,FileBuffer2,cBufSize);
    strcpy(FileBuffer,FileBuffer2);
    if (FileBuffer[0]=='[') continue;
    if (SplitLine(SplitPoint,"=","",FileBuffer,cBufSize)!=2) {
      sprintf(FileBuffer,
              "Warning: Config File Syntax Error at Line %d",LineNo);
      PutMessage1(FileBuffer);
      continue;
    }
    if (strcmp(SplitPoint[0],"FILETYPE")==0) {
      int i;
      FileTypeCheck_T *F;
      char str0[cBufSize];
      strcpy(str0,SplitPoint[1]);
      if (SplitLine(SplitPoint,";","",str0,3)!=3) {
        sprintf(FileBuffer,
                "Warning: Config File Syntax Error at Line %d",LineNo);
        PutMessage1(FileBuffer);
        continue;
      }
      i=newFileType();
      F=FileTypeBlock+i;
      F->CheckType=SplitPoint[0][0];
      F->Command=newString(SplitPoint[2]);
      if (islower(F->CheckType)) ToLowerLine(SplitPoint[1]);
      if (F->CheckType=='n' || F->CheckType=='m') {
        F->nKeyword=1;
        F->KeywordLength=newInteger(1);
        IntegerBlock[F->KeywordLength]=strlen(SplitPoint[1]);
        F->Keyword=newInteger(1);
        IntegerBlock[F->Keyword]=newString(SplitPoint[1]);
      } else {
	char str1[cBufSize];
	strcpy(str1,SplitPoint[1]);
        F->nKeyword=SplitLine(SplitPoint,",","",
                              SplitPoint[1],strlen(SplitPoint[1]));
        F->Keyword=newInteger(F->nKeyword);
        F->KeywordLength=newInteger(F->nKeyword);
        for(i=0;i<F->nKeyword;i++){
          IntegerBlock[F->Keyword+i]=newString(SplitPoint[i]);
          IntegerBlock[F->KeywordLength+i]=strlen(SplitPoint[i]);
        }
      }
    } else if (strcmp(SplitPoint[0],"DEFAULTFILE")==0) {
      newDefaultFile(SplitPoint[1]);
    } else if (strcmp(SplitPoint[0],"PLUGINPATH")==0){
      PlugInPath=newString(SplitPoint[1]);
    } else if (strcmp(SplitPoint[0],"PLUGINFILE")==0){
      PlugInFileSet=newString(SplitPoint[1]);
    } else {
      sprintf(FileBuffer,
              "Warning: Unknown Keyword at Config File Line %d",LineNo);
      PutMessage1(FileBuffer);
    }
  }
  return 1;
}

SV_Function int Q_strcmp(const void *s0, const void *s1) 
{
  return strcmp(StringBlock2+*(int *)s0,StringBlock2+*(int *)s1);
}

SV_Function int SearchKeyword1(char *Keyword,int nWord,int *WordList) 
{
  int i,j,SPoint,LPoint;
  SPoint=0;
  LPoint=nWord-1;
  while(SPoint <= LPoint) {
    i=(SPoint+LPoint)/2;
    /*fprintf(stderr,"Compare:%s:%s:\n",Keyword,StringBlock2+WordList[i]);*/
    j=strcmp(StringBlock2+WordList[i],Keyword);
    if (j==0) return i;
    if (j<0) SPoint=i+1; else LPoint=i-1;
  }
  return -1;
}

SV_Function int SearchKeyword2(char *Keyword,int nWord,char **WordList) 
{
  int i,j,SPoint,LPoint;
  SPoint=0;
  LPoint=nWord-1;
  while(SPoint <= LPoint) {
    i=(SPoint+LPoint)/2;
    j=strcmp(WordList[i],Keyword);
    if (j==0) return i;
    if (j<0) SPoint=i+1; else LPoint=i-1;
  }
  return -1;
}

SV_Function int SearchKeyword(FileTypeCheck_T *F,int nWord,int *WordList) 
{
  int i,Found;
  for(i=0;i<F->nKeyword;i++) {
    Found=TRUE;
    if (SearchKeyword1(StringBlock+IntegerBlock[F->Keyword+i],
                       nWord,WordList)<0) {
      Found=FALSE;
      break;
    }
  }
  return Found;
}

SV_Variable int MAX_STRING2;
SV_Variable char *StringBlock2;
SV_Variable int nStringLength2;

/* Local Function for DetectFileType */
SV_LocalFunction int newString2(char *string) 
{
  int size;
  size=strlen(string)+1;
  if (MAX_STRING2<=nStringLength2+size) {
    int I;
    I=STRING_BLOCK_SIZE;
    while(MAX_STRING2+I<=nStringLength2+size) {
      I+=STRING_BLOCK_SIZE;
    }
    StringBlock2=Realloc(StringBlock2,&MAX_STRING2,I,1);
  }
  strcpy(StringBlock2+nStringLength2,string);
  nStringLength2+=size;
  return nStringLength2-size;
}

SV_Variable int MAX_WORD;
SV_Variable int *WordList;
SV_Variable int *LowerWordList;
SV_Variable int *WordLengthList;
SV_Variable int nWord;

SV_LocalFunction int newWord(char *word)
{
  if (nWord+1>=MAX_WORD) {
    int I=MAX_WORD;
    WordList=Realloc(WordList,&MAX_WORD,SVX_BLOCK_SIZE,sizeof(int));
    LowerWordList=Realloc(LowerWordList,&I,SVX_BLOCK_SIZE,sizeof(int));
  }
  WordList[nWord]=newString2(word);
  LowerWordList[nWord]=newString2(word);
  ToLowerLine(StringBlock2+LowerWordList[nWord]);
  nWord++;
  return nWord-1;
}

SV_Function int DetectFileType(char *FileName) 
{
  FILE *fp;
  int i;
  int FileType;
  char FileBuffer[cBufSize];
  char Line0[cBufSize],LowerLine0[cBufSize];
  int Line0Length;
  int FileNameLength;
  int LowerFileName;

  MAX_STRING2=0;
  StringBlock2=NULL;
  nStringLength2=0;

  MAX_WORD=0;
  WordList=NULL;
  LowerWordList=NULL;
  WordLengthList=NULL;
  nWord=0;

  fp=ffopen(FileName,"r");
  if (fp==0) return -1;
  FileNameLength=strlen(FileName);
  LowerFileName=newString2(FileName);
  ToLowerLine(StringBlock2+LowerFileName);

  Line0Length=fread(Line0,1,cBufSize-1,fp);
  for(i=0;i<Line0Length;i++) {
    LowerLine0[i]=isalpha(Line0[i])?tolower(Line0[i]):Line0[i];
  }
  fseek(fp,0,SEEK_SET);
  while(nWord<cBufSize && fgets(FileBuffer,cBufSize,fp)) {
    Chop(FileBuffer);
    PackLine2(FileBuffer);
    nSplitPoint=SplitLine(SplitPoint," \t","",FileBuffer,cBufSize);
    for(i=0;i<nSplitPoint;i++){
      newWord(SplitPoint[i]);
      if (nWord>=cBufSize) break;
    }
  }
  fclose(fp);
  qsort(WordList,nWord,sizeof(int),Q_strcmp);
  qsort(LowerWordList,nWord,sizeof(int),Q_strcmp);
  FileType=-1;
  for(i=0;i<nFileType;i++) {
    FileTypeCheck_T *F;
    char *TempString;
    F=FileTypeBlock+i;
    switch(F->CheckType) {
    case 'm':
    case 'M':
      TempString=(F->CheckType=='M')?Line0:LowerLine0;
      if (FindLine(TempString,StringBlock+IntegerBlock[F->Keyword])==0) {
        FileType=i;
      }
      break;
    case 'n':
    case 'N':
      TempString=(F->CheckType=='N')?FileName:StringBlock2+LowerFileName;
      if (IntegerBlock[F->KeywordLength] > FileNameLength) break;
      if (FindLine(TempString+FileNameLength-IntegerBlock[F->KeywordLength],
                   StringBlock+IntegerBlock[F->Keyword])==0) {
        FileType=i;
      }
      break;
    case 'k':
      if (SearchKeyword(F,nWord,LowerWordList)) FileType=i;
      break;
    case 'K':
      if (SearchKeyword(F,nWord,WordList)) FileType=i;
      break;
    }
    if (FileType>=0) {
      /*      fprintf(stderr,"KEY: %c %d '%s'\n",
	      F->CheckType,FileType,StringBlock2+LowerWordList[1]); */
      break;
    } 
  }
  Free(StringBlock2);
  Free(WordList);
  Free(LowerWordList);
  Free(WordLengthList);
  return FileType;
}


