/* File Convert Module (Any Format -> sv Format) "getloc.c" -*- C -*- */
#define __svx_c_proc__
#define __getloc_c__
#define __filetype_c_proc__
#define __string_proc__
#define __syssub__
#include "def.h"
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

SV_Function void PrintAtom(FILE *fp,char *AtomName,int elem,double x,double y,double z,double occ,double Uiso,double PeakHeight,int frag,int part,int afix) 
{
  fprintf(fp,"ATOM %-4s %2d %10.6f%10.6f%10.6f %6.2f %10.6f "
          "%6.2f %2d %2d %3d\n",
          AtomName,elem,x,y,z,occ,Uiso,PeakHeight,frag,part,afix);
}

SV_Function void PrintUij(FILE *fp,double *Uij) 
{
    fprintf(fp,"UIJ  %10.6f %10.6f %10.6f %10.6f %10.6f %10.6f\n",
            Uij[0],Uij[1],Uij[2],Uij[3],Uij[4],Uij[5]);
}
  
int ReplaceOnLine(char *text,char *org,char *replace) {
  char Buffer[cBufSize];
  ReplaceLine(text,Buffer,org,replace);
  strcpy(text,Buffer);
  return 1;
}

void DecodeSymmetryString(char *SymmetryText,FILE *fp) {
  char STmp[100],STmp2[100];
  int n,i;
  Double tmp;
  Double S[3][4];
  ReplaceLine(SymmetryText,STmp,"'","");
  ToUpperLine(STmp);
  ReplaceOnLine(STmp," ","");
  strcpy(STmp2," ");
  strcat(STmp2,STmp);
  ReplaceOnLine(STmp2,","," M , ");
  ReplaceOnLine(STmp2," X"," +1 X");
  ReplaceOnLine(STmp2," Y"," +1 Y");
  ReplaceOnLine(STmp2," Z"," +1 Z");
  ReplaceOnLine(STmp2,"+"," M +");
  ReplaceOnLine(STmp2,"-"," M -");
  ReplaceOnLine(STmp2,"+X"," +1 X");
  ReplaceOnLine(STmp2,"+Y"," +1 Y");
  ReplaceOnLine(STmp2,"+Z"," +1 Z");
  ReplaceOnLine(STmp2,"-X"," -1 X");
  ReplaceOnLine(STmp2,"-Y"," -1 Y");
  ReplaceOnLine(STmp2,"-Z"," -1 Z");
  ReplaceOnLine(STmp2,"X"," X");
  ReplaceOnLine(STmp2,"Y"," Y");
  ReplaceOnLine(STmp2,"Z"," Z");
  strcat(STmp2," M ,");
  PackLine(STmp2);
  /* fprintf(fp,"%s\n",STmp2);*/
  nSplitPoint=SplitLine(SplitPoint," \t","-+",STmp2,100);
  n=0;
  tmp=0;
  for(i=0;i<3;i++){
    S[i][0]=S[i][1]=S[i][2]=S[i][3]=0;
    while (strcmp(SplitPoint[n],",")!=0) {
      char c;
      c=SplitPoint[n][0];
      switch(c){
      case 'M':
        S[i][0]+=tmp;
        tmp=0;
        break;
      case 'X':
        S[i][1]+=tmp;
        tmp=0;
        break;
      case 'Y':
        S[i][2]+=tmp;
        tmp=0;
        break;
      case 'Z':
        S[i][3]+=tmp;
        tmp=0;
        break;
      default:
        if (strchr(SplitPoint[n],'/')!=NULL) {
          tmp=atof(SplitPoint[n])/atof(strchr(SplitPoint[n],'/')+1);
        } else {
          tmp=atof(SplitPoint[n]);
        }
      }
      n++;
    }
    n++;
    tmp=0;
  }
  fprintf(fp,"SYMM %10.6f %3.0f %3.0f %3.0f %10.6f %3.0f %3.0f " 
          "%3.0f %10.6f %3.0f %3.0f %3.0f\n", 
          S[0][0],S[0][1],S[0][2],S[0][3],
          S[1][0],S[1][1],S[1][2],S[1][3],
          S[2][0],S[2][1],S[2][2],S[2][3]);
}

SV_LocalVariable char *CmdListShelxl[]
={
  "",    " ",   "  ",  "   ", "    ",
  "$H",  "$H ", "$H  ",
  "ABSC","ACTA","AFIX","AFLS","ANIS",
  "BASF","BIND","BLOC","BOND","BUMP",
  "CELL","CGLS","CHIV","CODE","CONF",
  "CONN","DAMP","DANG","DEFS","DELU",
  "DFIX","DISP","DMAT","EADP","EMPI",
  "END ","END","EQIV","ESEL","EXTI",
  "EXYZ","FACE","FEND","FLAT","FMAP","FRAG",
  "FREE","FVAR","GRID","HFIX","HKLF",
  "HOPE","HTAB","ILSF","ISOR","L.S.",
  "LAMI","LATT","LAUE","LIST","MERG",
  "MFIT","MOLE","MORE","MOVE","MPLA",
  "NCSY","NODE","OMIT","PART","PATT",
  "PHAS","PLAN","PSEE","READ","REM ",
  "REM","RESI","REST","RFOM","ROTS",
  "RTAB","SADI","SAME","SFAC","SHEL",
  "SIMU","SIZE","SKIP","SLIM","SPEC",
  "SPIN","STIR","SUBS","SUMP","SWAT",
  "SYMM","TEMP","TEXP","TFOM","TIME",
  "TITL","TRAN","TREF","TWIN","TWIS",
  "UNDO","UNIT","WGHT","WPDB","ZERR"
};

const int nCmdListShelxl=109;

void AppendFile(FILE *fpdest,FILE *fpadd) {
  char FileBuffer[cBufSize];
  while(fgets(FileBuffer,cBufSize,fpadd)!=0){
    fprintf(fpdest,FileBuffer);
  }
}

SV_Function int getlocl(char *FileName)
{
  FILE *fpAll,*fpShelx;
  char FileBuffer[cBufSize],FileBuffer2[cBufSize],cmd[5];
  int part=0,frag=0,afix=0;
  fpShelx=ffopen(FileName,"r");
  if (fpShelx==NULL) {
    sprintf(FileBuffer,"Can't Open '%s'",FileName);
    PutMessage1(FileBuffer);
    return 0;
  }
  fpAll=ffopen("atoms.svx","w");
  if (fpAll==NULL) {
    fclose(fpShelx);
    PutMessage1("Can't Open SV Temporary File.");
    return 0;
  }
  fprintf(fpAll,"%s\n","FILE SVX 2.0");
  while(fgets(FileBuffer,cBufSize,fpShelx)!=NULL) {
    Chop(FileBuffer);
    if (strlen(FileBuffer)<4) strcat(FileBuffer,"    ");
    strncpy(cmd,FileBuffer,4);
    cmd[4]=0;
    ToUpperLine(cmd);
    if (strcmp(cmd,"REM ")==0 || strcmp(cmd,"    ")==0 || cmd[0]=='+')
      continue;
    while (FileBuffer[strlen(FileBuffer)-1]=='=') {
      FileBuffer[strlen(FileBuffer)-1]=0;
      fgets(FileBuffer2,cBufSize,fpShelx);
      Chop(FileBuffer2);
      PackLine(FileBuffer2);
      strcat(FileBuffer," ");
      strcat(FileBuffer,FileBuffer2);
    }
    if (strlen(FileBuffer)>4) PackLine(FileBuffer+4);
    strcpy(FileBuffer2,FileBuffer);
    nSplitPoint=SplitLine(SplitPoint," \t","-+",FileBuffer+4,cBufSize);
    
    if (strcmp(cmd,"TITL")==0) {
      fprintf(fpAll,"TITL %s\n",FileBuffer2+4);
    } else if (strcmp(cmd,"CELL")==0) {
      int i;
      fprintf(fpAll,"CELL ");
      for(i=0;i<6;i++) {
        fprintf(fpAll,"%10.6f ",atof(SplitPoint[i+1]));
      }
      fprintf(fpAll,"\n");
    } else if (strcmp(cmd,"LATT")==0) {
      fprintf(fpAll,"LATT %d\n",atoi(SplitPoint[0]));
    } else if (strcmp(cmd,"SFAC")==0) {
      if (nSplitPoint<3 || (isalpha(SplitPoint[1][0]) && isalpha(SplitPoint[2][0]))) {
        int i;
        for(i=0;i<nSplitPoint;i++){
          fprintf(fpAll,"ELEM %-2s\n",SplitPoint[i]);
        };
      } else {
        fprintf(fpAll,"ELEM %-2s\n",SplitPoint[0]);
      }
    } else if (strcmp(cmd,"SYMM")==0) {
      char SymBuf[80];
      strcpy(SymBuf,FileBuffer2+4);
      PackLine(SymBuf);
      DecodeSymmetryString(SymBuf,fpAll);
    } else if (strcmp(cmd,"FVAR")==0) {
      int i;
      for(i=0;i<nSplitPoint;i++) {
        fprintf(fpAll,"FVAR %10.6f\n",atof(SplitPoint[i]));
      }
    } else if (strcmp(cmd,"PART")==0) {
      part=atoi(SplitPoint[0]);
    } else if (strcmp(cmd,"MOLE")==0) {
      frag=atoi(SplitPoint[0]);
    } else if (strcmp(cmd,"AFIX")==0) {
      afix=atoi(SplitPoint[0]);
    } else if (strcmp(cmd,"HKLF")==0) {
      afix=part=0;
    } else if (SearchKeyword2(cmd,nCmdListShelxl,CmdListShelxl)<0) {
      char AtomName[5];
      double x,y,z,PeakHeight,occ,Uiso;
      int elem,i;
      strncpy(AtomName,FileBuffer2,4);
      AtomName[4]=0;
      elem=atoi(SplitPoint[0]);
      x=atof(SplitPoint[1]);
      y=atof(SplitPoint[2]);
      z=atof(SplitPoint[3]);
      PeakHeight = 0;
      if (AtomName[0]=='Q') {
        PeakHeight=atof(SplitPoint[6]);
        elem=0;
      } 
      occ = atof(SplitPoint[4]);
      if (nSplitPoint>7) Uiso=0; else Uiso=atof(SplitPoint[5]);
      PrintAtom(fpAll,AtomName,elem,x,y,z,occ,Uiso,PeakHeight,frag,part,afix);
      if (afix==66) afix=65;
      if (afix==55) afix=56;
      if (nSplitPoint>7) {
        Double Uij[6];
        int i;
        for(i=0;i<6;i++) {
          Uij[i]=atof(SplitPoint[5+i]);
        }
        PrintUij(fpAll,Uij);
      }
    }
  }
  fclose(fpAll);
  fclose(fpShelx);
  return 1;
}


SV_LocalFunction const char *substr(char *str,int start,int len) 
{
  static char buf[82];
  int i;
  if (len>80) len=80;
  for(i=0;i<len;i++){
    buf[i]=str[start+i];
  }
  buf[i]=0;
  return buf;
}
  
SV_Function int getloccsd(char *FileName)
{
  FILE *fpAll,*fpCSD;
  char **dataname;
  int FilePointer[cBufSize];
  char DataName[9];
  int i,j,k;
  int n_data,n_atm,latt,n_line,n_sym,dummy;
  char FileBuffer[cBufSize],FileBuffer2[cBufSize];
  int atfor;
  fpCSD=ffopen(FileName,"r");
  if (fpCSD==NULL) {
    sprintf(FileBuffer,"Can't Open '%s'",FileName);
    PutMessage1(FileBuffer);
    return 0;
  }
  fpAll=ffopen("atoms.svx","w");
  if (fpAll==NULL) {
    fclose(fpCSD);
    PutMessage1("Can't Open SV Temporary File.");
    return 0;
  }
  dataname=Malloc(sizeof(char *)*cBufSize);
  if (dataname==NULL) {
    PutMessage1("Out of Memory !");
    fclose(fpAll);
    fclose(fpCSD);
    return 0;
  }
  n_data=0;
  FilePointer[0]=0;
  while(fgets(FileBuffer,cBufSize,fpCSD)!=NULL && n_data<cBufSize-1) {
    if (FileBuffer[0]=='#') {
      dataname[n_data]=(char *)Malloc(sizeof(char)*9);
      strncpy(dataname[n_data],FileBuffer+1,8);
      dataname[n_data++][8]=0;
    }
    FilePointer[n_data]=ftell(fpCSD);
  }
  i=SelectItem("Select Data",n_data,dataname);
  if (i>=0) {
    strcpy(DataName,dataname[i]);
    fseek(fpCSD,0,FilePointer[i]);
  }
  for(j=0;j<n_data;j++) Free(dataname[j]);
  Free(dataname);
  if (i<0) {
    PutMessage1("Canceled");
    fclose(fpAll);
    fclose(fpCSD);
    return 0;
  }
  fprintf(fpAll,"%s\n","FILE SVX 2.0");
  fprintf(fpAll,"TITL %s\n",DataName);
  fgets(FileBuffer,cBufSize,fpCSD);
  n_atm=atoi(substr(FileBuffer,44,3));
  latt=atoi(substr(FileBuffer,59,1));
  if (latt!=1) latt=-1;
  fprintf(fpAll,"LATT %d\n",latt);
  n_sym=atoi(substr(FileBuffer,38,3));
  atfor=atoi(substr(FileBuffer,58,1));
fprintf(stderr,"n_sym=%d\n",n_sym);
  atfor=5-atfor;
  dummy=atoi(substr(FileBuffer,56,1));
  n_line=(atoi(substr(FileBuffer,26,3))+
	  atoi(substr(FileBuffer,29,3))+
	  atoi(substr(FileBuffer,32,3))+
	  atoi(substr(FileBuffer,35,3))+79)/80;
  if (dummy==0) {
    PutMessage1("No Cell Information!");
    fclose(fpAll);
    fclose(fpCSD);
    return 0;
  }
  fgets(FileBuffer,80,fpCSD);
  /*  sscanf(FileBuffer,"%06d%06d%06d%06d%06d%06d%01d%01d%01d%01d%01d%01d",
         cel,cel+1,cel+2,cel+3,cel+4,cel+5,
         cel2,cel2+1,cel2+2,cel2+3,cel2+4,cel2+5);*/
  fprintf(fpAll,"CELL ");
  for(i=0;i<6;i++) {
    fprintf(fpAll,"%10.6f ",((Float)atoi(substr(FileBuffer,6*i,6)))*
	    pow(0.1,(Float)atoi(substr(FileBuffer,36+i,1))));
  }
  fprintf(fpAll,"\n");

  for(i=0;i<n_line;i++) fgets(FileBuffer,cBufSize,fpCSD);
fprintf(stderr,"%d\n",n_line);
  for(i=0;i<(n_sym+4)/5;i++) {
    fgets(FileBuffer,cBufSize,fpCSD);
    for(j=0;j<5;j++) {
      if (i*5+j<n_sym && strncmp(FileBuffer+j*15,"211 0121 0112 0",15)!=0) {
	char *t;
        fprintf(fpAll,  "SYMM ");
	for(k=0;k<3;k++){
	  t=FileBuffer+j*15+k*5;
	  fprintf(fpAll,"%10.6f %3.0f %3.0f %3.0f ",
		  ((Float)atoi(substr(t,3,2)))/12,
		  (Float)atoi(substr(t,0,1))-1,
		  (Float)atoi(substr(t,1,1))-1,
		  (Float)atoi(substr(t,2,1))-1);
	}
	fprintf(fpAll,"\n");
      }
    }
  }
  fgets(FileBuffer,cBufSize,fpCSD);
  Chop(FileBuffer);
  PackLine2(FileBuffer);
  nSplitPoint=SplitLine(SplitPoint," \t","-+",FileBuffer,cBufSize);
  for(i=0;i<nSplitPoint;i++){
    fprintf(fpAll,"ELEM %2s\n",SplitPoint[i]);
  }

  {
    int col,w,sc;
    if (atfor==4) {
      col=20;
      w=5;
      sc=10000;
    } else {
      col=27;
      w=7;
      sc=100000;
    }
    for(i=0;i<(n_atm+atfor-1)/atfor;i++) {
      fgets(FileBuffer2,cBufSize,fpCSD);
      for(j=0;j<atfor;j++){
        if (i*atfor+j<n_atm) {
          char AtomName[6],At2[3];
          int elem_no;
	  int coord[3];
	  strcpy(AtomName,substr(FileBuffer2,col*j,5));
	  for(k=0;k<3;k++){
	    coord[k]=atoi(substr(FileBuffer2,col*j+5+k*w,w));
	  }
          At2[0]=AtomName[0];
          At2[1]=AtomName[1];
          if (!isalpha(At2[1])) At2[1]=0;
          At2[2]=0;
          elem_no=0;
          for(k=0;k<nSplitPoint;k++){
            if (strcmp(At2,SplitPoint[k])==0) {
              elem_no=k+1;
            }
          }
          PrintAtom(fpAll,AtomName,elem_no,
                    ((Float)coord[0])/sc,((Float)coord[1])/sc,
		    ((Float)coord[2])/sc,
                    1.0,0.06,0,1,0,0);
        }
      }
    }
  }

  fclose(fpAll);
  fclose(fpCSD);
  return 1;
}











