/* Global Variable Define   "global.c"     -*- C -*- */

/*
#S#
#
# This Program is part of SV (Shelx-output Viewer)
# Copyright (C) 1991-1998 Takashi Nemoto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details. (File "COPYING")
#
#    Note!: General Public Licence is copyrighted by the Free Software 
#           Foundation,  but this code is copyrighted by me.
#
#    Send bugs and comments to tnemoto@eels.kuicr.kyoto-u.ac.jp
#
#E#
*/

#define __global_c__
#define __string_proc__
#include "def.h"

SV_GlobalVariable int PlugInPath;
SV_GlobalVariable int PlugInFileSet;

SV_GlobalVariable char ARG0[cBufSize];
SV_GlobalVariable char curwd[cBufSize];
SV_GlobalVariable char cmd_que[cBufSize];
SV_GlobalVariable char fbuf[cBufSize];
SV_GlobalVariable char fbuf2[cBufSize];

SV_GlobalVariable int MAX_ATOM;
SV_GlobalVariable int MAX_BOND;
SV_GlobalVariable int MAX_SYMATOM;
SV_GlobalVariable char Title[cBufSize];
SV_GlobalVariable Double symm[MAX_SYMM][3][4];
SV_GlobalVariable int SEARCH_MAX,SEARCH_MIN;
SV_GlobalVariable int global_flag;
SV_GlobalVariable Double MAT[3][3];
SV_GlobalVariable Double VMT[3][3];
SV_GlobalVariable Double matrix[3][3];
SV_GlobalVariable Double ZVIEW;
SV_GlobalVariable int LATT;
SV_GlobalVariable int symnum;
SV_GlobalVariable int n_atom;
SV_GlobalVariable int n_satom;
SV_GlobalVariable int n_bond;
SV_GlobalVariable int n_sfac;
SV_GlobalVariable VDW sfac[MAX_SFAC];
SV_GlobalVariable ATOM_PARAM *orgAtom,CELL[5];
SV_GlobalVariable BOND_PARAM *BOND,BCELL[12];
SV_GlobalVariable S_AT *SAT,SYMCELL[8];

SV_GlobalVariable int **BondMatrix,*BondMat;
SV_GlobalVariable int **BondMatrix2,*BondMat2,*nBondMatrix;
SV_GlobalVariable int *BondTag0,*BondTag1,*BondTag2;

SV_GlobalVariable Double scale[3],offst[3],vscale;
SV_GlobalVariable Double shift[2];
SV_GlobalVariable Double sshift[3];
SV_GlobalVariable Double ssplit;
SV_GlobalVariable Double avg[3];
SV_GlobalVariable Double cell[6],rcell[6];
SV_GlobalVariable Double cell_cos[3],cell_sin[3],cell_cos_s[3],cell_sin_s[3];
SV_GlobalVariable char disp_str[110][40];
SV_GlobalVariable FILE *log_fp
                             =0;

#ifdef IGraph
SV_GlobalVariable IGraph_Arcs iarcs[MAX_IARCS];
SV_GlobalVariable IGraph_Lines ilines[MAX_ILINES];
SV_GlobalVariable Double iorgs[MAX_IORGS][3];
SV_GlobalVariable Double irvmts[MAX_IRVMTS][3][3];
SV_GlobalVariable int n_iarcs
                          =0;
SV_GlobalVariable int n_ilines
                           =0;
SV_GlobalVariable int n_irvmts
                           =0;
SV_GlobalVariable int n_iorgs
                           =0;
#endif

SV_GlobalFunction char *filename(char *path,char *name)
{
  static char fname[cBufSize];
  int l;
  if (name[0]=='/' || name[0]=='\\' || name[1]==':') return name;
  l=strlen(path);
  if (l!=0 &&  path[l-1]!='/' && path[l-1]!='\\') {
    sprintf(fname,"%s%c%s",path,FileDelimitor,name);
  } else {
    sprintf(fname,"%s%s",path,name);
  }
/*  PutMessage1(fname); */
  return fname;
}

SV_GlobalFunction FILE *ffopen(char *name,char *mode)
{
  return fopen(filename(curwd,name),mode);
}



