/* Graphics Library (Post Script) Module   "shelplot.c"    -*- C -*-  */

/*
#S#
#
# This Program is part of SV (Shelx-output Viewer)
# Copyright (C) 1991-1998 Takashi Nemoto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details. (File "COPYING")
#
#    Note!: General Public Licence is copyrighted by the Free Software 
#           Foundation,  but this code is copyrighted by me.
#
#    Send bugs and comments to tnemoto@eels.kuicr.kyoto-u.ac.jp
#
#E#
*/

#define __shelplot_c__
#define __cmd_c_proc__

#include "def.h"

SV_LocalVariable FILE *fp_ps;

/*********** for Post Script Printer *****************************/
SV_Function void PScolor(int color)
{
  static int prevColor=-1;
  static Double RGBColorTable[][3]={
    /* For Normal */
    {0,0,0},
    {0,0,1},
    {1,0,0},
    {1,0,1},
    {0,1,0},
    {0,1,1},
    {1,1,0},
    {1,1,1},

    /* For Reverse? */
    {0,0,0},
    {0,0,1},
    {1,0,0},
    {1,0,1},
    {0,1,0},
    {0,1,1},
    {1,1,0},
    {1,1,1},

    /* For Gray */
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
    {0,0,0},
  };

  if (fp_ps==NULL) return;
  if (color==prevColor) return;
  if (!(global_flag & GLOBALFLAG_BOND_COLOR)) return;

  prevColor=color;
  fprintf(fp_ps," %5.3f %5.3f %5.3f  setrgbcolor\n",
	  RGBColorTable[color][0],
	  RGBColorTable[color][1],
	  RGBColorTable[color][2]);
}

SV_Function int PSopen(void)
{
  fp_ps=ffopen("sv.ps","w");
  if (fp_ps==NULL) { return 0; } 
  fprintf(fp_ps,"%s\n","%!PS");
  fprintf(fp_ps,"save\n");
  fprintf(fp_ps,"/m {moveto} def\n/l {lineto} def\n/s {stroke} def\n");
  fprintf(fp_ps,"/h {/Helvetica findfont 10 scalefont setfont} def\n");
  fprintf(fp_ps,"/r {/Times-Roman findfont 10 scalefont setfont} def\n");
  fprintf(fp_ps,"gsave\n/Times-Italic findfont 30 scalefont setfont\n");
  fprintf(fp_ps,"/PRINTTITLE { 100 50 m (Shelx Output View) show } def\n");
  fprintf(fp_ps,"0 0.05 0.95 { 0 setgray PRINTTITLE setgray PRINTTITLE\n");
  fprintf(fp_ps,"-0.7 0.35 translate} for\n");
  fprintf(fp_ps,"0 setgray PRINTTITLE ");
  fprintf(fp_ps,"/Times-Roman findfont 15 scalefont setfont\n");
/*
  fprintf(fp_ps," (             Written by T. Nemoto) show \n");
*/
  fprintf(fp_ps,"grestore \n");
  fprintf(fp_ps,"r\n");
  fprintf(fp_ps,"0.1 setlinewidth\n");
  return 1;
}

SV_Function void PSline(Double x1,Double y1,Double x2,Double y2)
{
  if (fp_ps==NULL) return;
  fprintf(fp_ps,"%5.1f %5.1f m %5.1f %5.1f l s\n",
	x1*50+270,y1*50+350,x2*50+270,y2*50+350);
}

SV_Function void PSputs(Double x,Double y,char *txt)
{
  if (fp_ps==NULL) return;
  fprintf(fp_ps,"%5.1f %5.1f m (%s) show\n",x*50+270,y*50+350,txt);
}

SV_Function void PSclose(void)
{
  if (fp_ps==NULL) return;
  fprintf(fp_ps,"restore\nshowpage\n");
  fclose(fp_ps);
}


