/* File Detection Module "svx.c" -*- C -*- */
/*
#S#
#
# This Program is part of SV (Shelx-output Viewer)
# Copyright (C) 1991-1998 Takashi Nemoto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details. (File "COPYING")
#
#    Note!: General Public Licence is copyrighted by the Free Software 
#           Foundation,  but this code is copyrighted by me.
#
#    Send bugs and comments to tnemoto@eels.kuicr.kyoto-u.ac.jp
#
#E#
*/

#include <ctype.h>

#ifdef __MSWIN__
#include <windows.h>
#endif

#define __syssub__

#define __svx_c__
#define __filetype_c_proc__
#define __string_proc__
#define __getloc_c_proc__
#define __cmninit_c_proc__
#include <stdio.h>
#include "def.h"

SV_Function int svx(char *FileName)
{
  int i;
  char cmd[cBufSize],cmd2[cBufSize],FileBuffer[cBufSize],FileName2[cBufSize];
#ifdef DEBUG
  if (FileName==NULL) {
    fprintf(stderr,"Checking Default Files\n");
  } else {
    fprintf(stderr,"Checking \"%s\"\n",FileName);
  }
#endif
  if (FileName==NULL || FileName[0]==0) {
    for(i=0;i<nDefaultFile;i++){
#ifdef DEBUG
      fprintf(stderr,"Checking %d %s\n",i,StringBlock+DefaultFileList[i]);
#endif
      if (svx(StringBlock+DefaultFileList[i])==0) return 0;
    }
    return -1;
  }
  if (FileName[0]=='"' && FileName[strlen(FileName)-1]=='"') {
      FileName++;
      FileName[strlen(FileName)-1]=0;
  }
  strcpy(FileName2,FileName);
  sprintf(curwd,"%s",GetPathFromFileName(FileName2));
  i=DetectFileType(FileName2);
  if (i<0) {
#ifdef DEBUG
        sprintf(FileBuffer,"Can't detect file type! '%s'",FileName);
        PutMessage1(FileBuffer);
#endif
        return -1;
  }
  strcpy(cmd,StringBlock+FileTypeBlock[i].Command);
  nSplitPoint=SplitLine(SplitPoint," \t","",cmd,2);
  if (strcmp(SplitPoint[0],"exec")==0) {
    sprintf(cmd2,"%s %s",SplitPoint[1],FileName);
    system(cmd2);
  } else if (strcmp(SplitPoint[0],"wall")==0) {
    ChangeWallPaper(SplitPoint[1],FileName);
  } else if (strcmp(SplitPoint[0],"svx")==0) {
#ifdef DEBUG
    sprintf(FileBuffer,"SVX Internal Viewer : Type %s",SplitPoint[1]);
    PutMessage1(FileBuffer);
#endif
    if (log_fp!=NULL)CloseCrystalInitialize();
    if (strcmp(SplitPoint[1],"shelxl")==0 || 
        strcmp(SplitPoint[1],"shelxs")==0) {
        getlocl(FileName2);
    } else if (strcmp(SplitPoint[1],"csd")==0) {
      getloccsd(FileName2);
    } 
    OpenCrystalInitialize();
    return 0;
  } else if (strcmp(SplitPoint[0],"conv")==0) {
    char tmpcmd[1024];
    sprintf(tmpcmd,"%s %s",SplitPoint[1],FileName2);
    fprintf(stderr,"%s\n",tmpcmd);
    system(tmpcmd);
    OpenCrystalInitialize();
    return 0;
  }
  return -1;
}


