/* Xt CallBack/Interface Routines  "xtcalls.c"    -*- C -*-  */

/*
#S#
#
# This Program is part of SV (Shelx-output Viewer)
# Copyright (C) 1991-1998 Takashi Nemoto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details. (File "COPYING")
#
#    Note!: General Public Licence is copyrighted by the Free Software 
#           Foundation,  but this code is copyrighted by me.
#
#    Send bugs and comments to tnemoto@eels.kuicr.kyoto-u.ac.jp
#
#E#
*/

#define __xtcalls_c__
#define __xtmain_c_proc__
#define __shelplot_c_proc__
#define __main_c_proc__
#define __cmd_c_proc__
#define __panic_c_proc__
#define __stack_c_proc__
#define __atom_c_proc__
#define __bond_c_proc__
#define __view_c_proc__
#define __shelview_c_proc__

#define motion_detect 0.05

#include "def.h"

#ifdef Xt
#include <X11/cursorfont.h>
#endif

SV_LocalVariable int error_up
                          =0;
SV_LocalVariable int px,py;
SV_LocalVariable int RP_flag
                         =0;
SV_LocalVariable int cur_flag
                          =0;
SV_LocalVariable Cursor cursor;
SV_LocalVariable XtIntervalId rot_interval;
SV_LocalVariable int contstop;

SV_LocalVariable int keyinflag,*waitflag;

SV_Function int MouseX(void)
{
    int dx,dy,dummy0;
    Window dummy1;
    unsigned int dummy2;
    if (XQueryPointer(disp,win0,&dummy1,&dummy1,&dx,&dy,&dummy0,
                     &dummy0,&dummy2)==0) return 100;
    return dx;
}

SV_Function int MouseY(void)
{
    int dx,dy,dummy0;
    Window dummy1;
    unsigned int dummy2;
    if (XQueryPointer(disp,win0,&dummy1,&dummy1,&dx,&dy,&dummy0,
                     &dummy0,&dummy2)==0) return 100;
    return dy;
}

SV_Function void MouseMoveto(Widget w)
{
  XWarpPointer(disp,None,XtWindow(w),0,0,0,0,0,0);
}

SV_Function int KeyInput(char *mess,char *init,char *buf,int len)
{
  int i;
  char *buf0;
  XtSetArg(arg[0],XtNlabel,mess);
  XtSetArg(arg[1],XtNvalue,(XtArgVal)init);
  XtSetValues(dialogwin,arg,2);
  XtSetArg(arg[0],XtNx,MouseX()-30);
  XtSetArg(arg[1],XtNy,MouseY()-30);
  XtSetValues(dialogroot,arg,2);
  XtPopup(dialogroot,XtGrabExclusive);
  MouseMoveto(dialogok);
  keyinflag=0;
  do {
    XEvent ev;
    XtAppNextEvent(app_context,&ev);
    XtDispatchEvent(&ev);
  } while (keyinflag==0);
  XtPopdown(dialogroot);
  buf0=XawDialogGetValueString(dialogwin);
  for(i=0;i<len;i++) {
    buf[i]=buf0[i];
  };
  for(i=0;i<strlen(buf);i++){
    if (buf[i]=='\n') buf[i]=0;
  }
  return (keyinflag==1);
}

SV_Function void DialogCancel(Widget w,XtPointer closure,XtPointer dat)
{
  keyinflag=-1;
}

SV_Function void DialogOk(Widget w,XtPointer closure,XtPointer dat)
{
  keyinflag=1;
}

SV_Function void WaitWin(char *mess1,char *mess2,int fl,int *w_flag)
{
  waitflag=w_flag;
  XtSetArg(arg[0],XtNlabel,mess1);
  XtSetValues(waitlabel0,arg,1);
  XtSetArg(arg[0],XtNlabel,mess2);
  XtSetValues(waitlabel1,arg,1);
  *waitflag=0;
  XtSetArg(arg[0],XtNx,MouseX()-30);
  XtSetArg(arg[1],XtNy,MouseY()-30);
  XtSetValues(waitroot,arg,2);
  XtPopup(waitroot,XtGrabExclusive);
  MouseMoveto(waitint);
}

SV_Function void WaitMess(char *mess2)
{
  XtSetArg(arg[0],XtNlabel,mess2);
  XtSetValues(waitlabel1,arg,1);
}

SV_Function void WaitEnd(void)
{
  *waitflag=-1;
  XtPopdown(waitroot);
}

SV_Function void WaitInt(Widget w,XtPointer closure,XtPointer dat)
{
  *waitflag=1;
}

SV_Function void OrtOut(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("ortep");
}

SV_Function void Ort3Out(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("ortep3");
}

SV_Function void CharonOut(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("export charon");
}

SV_Function void ChemRayOut(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("export chemray");
}

SV_Function void RasMolOut(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("export rasmol");
}

SV_Function void CavOut(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("cavity");
}

SV_Function void CsdOut(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("export csd");
}

SV_Function void ShelxOut(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("export shelxl");
}

SV_Function void ChemDrawOut(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("export chemdraw");
}

SV_Function void MacTEMpasOut(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("export mactempas");
}

/* Function void ErrorPopup(char *text)
{
  if (error_up==0) {
    error_up=1;
    XtSetArg(arg[0],XtNlabel,text);
    XtSetValues(errorlabel,arg,1);
    XtPopup(errorroot,XtGrabNone);
    xtFlush();
  };
}*/

/* Function void ErrorPopdown(void)
{
  XtPopup(errorroot,XtGrabNone);
  XtPopdown(errorroot);
  error_up=0;
}*/

SV_Function void ErrorPopup(char *text)
{
  XtSetArg(arg[0],XtNlabel,text);
  XtSetValues(errorlabel,arg,1);
}

SV_Function void ErrorPopdown(void)
{
  errorbuf[0]=0;
  ErrorPopup("");
}


SV_Function void RotPopup(Widget w,XtPointer closure,XtPointer dat)
{
  XtPopup(rotpanelroot,XtGrabNone);
  RP_flag=1;
}

SV_Function void RotPanel(Widget w,XtPointer closure,XtPointer dat)
{
  RP_flag=1-RP_flag;
  if (RP_flag==1) {
    XtSetArg(arg[0],XtNx,MouseX());
    XtSetArg(arg[1],XtNy,MouseY());
    XtSetValues(rotpanelroot,arg,2);

    XtPopup(rotpanelroot,XtGrabNone);
  } else {
    XtPopdown(rotpanelroot);
  }
  XtSetArg(arg[0],XtNleftBitmap,RP_flag==1 ? check_mark : None);
  XtSetValues(w,arg,1);
}

SV_Function void RotPopdown(Widget w,XtPointer closure,XtPointer dat)
{
  XtPopdown(rotpanelroot);
  RP_flag=0;
  XtSetArg(arg[0],XtNleftBitmap,None);
  XtSetValues(modepanels[4],arg,1);
}

SV_Function void DepthCont(Widget w,XtPointer closure,XtPointer dat)
{
  if (contstop>0) contstop--; else if (contstop==0) depth();
  if (contstop==0){
    rot_interval=XtAddTimeOut(50,(XtTimerCallbackProc)DepthCont,NULL);
  }
}

SV_Function void DepthP1(Widget w,XtPointer closure,XtPointer dat)
{
  cmd_c=1;
  cmd_param[0][0]=0;
  cmd_num[0]=1;
  depth();
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)DepthCont,NULL);
  contstop=1;
}

SV_Function void DepthM1(Widget w,XtPointer closure,XtPointer dat)
{
  cmd_c=1;
  cmd_param[0][0]=0;
  cmd_num[0]=-1;
  depth();
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)DepthCont,NULL);
  contstop=1;
}

SV_Function void DispDepth(void)
{
}

SV_Function void ClearStack(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("clearstack");
/*
  stack_clr();
  DispStack(w,closure,dat);
*/
}

SV_Function void RestoreStack(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("restorestack");
/*
  stack_restore();
  DispStack(w,closure,dat);
*/
}

SV_Function void MakeBond(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("makebond sl");
}

SV_Function void DelBond(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("delbond sl");
}

SV_Function void MakeBondPair(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("makebond pa");
}

SV_Function void DelBondPair(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("delbond pa");
}

SV_Function void OmitAtom(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("omit sl");
}

SV_Function void DispStack(Widget w,XtPointer closure,XtPointer dat)
{
  /*  refresh(); */
  gdisp_atom_stack();
}


SV_Function void ReadFile(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("openfile");
}

SV_Function void ShiftMouse(Widget w,XtPointer closure,XtPointer dat)
{
  int dx,dy,gf;
  XEvent *ev;
  ev=(XEvent *)closure;
  gf=global_flag;
  global_flag&=~GLOBALFLAG_TMP_LABEL;
  dx=(ev->xmotion.x)-WinWidthHalf;
  dy=(ev->xmotion.y)-WinHeightHalf;
  shift[0]-=((Double)dx-px)/WinScale/vscale;
  shift[1]+=((Double)dy-py)/WinScale/vscale;
  cur_flag=1;
  refresh();
  cur_flag=0;
  global_flag=gf;
  px=dx;
  py=dy;
}

SV_Function void RotMouse(Widget w,XtPointer closure,XtPointer dat)
{
  int dx,dy,gf;
  Double r,r2,theta,theta2;
  XEvent *ev;
  ev=(XEvent *)closure;
  gf=global_flag;
  global_flag&=~GLOBALFLAG_TMP_LABEL;
  dx=(ev->xmotion.x)-WinWidthHalf;
  dy=(ev->xmotion.y)-WinHeightHalf;
  r2=sqrt((Double)dx*dx+dy*dy);
  if (r2>WinScale*1.5)
    {
      r=sqrt((Double)px*px+py*py);
      theta=atan2((Double)py,(Double)px);
      theta2=atan2((Double)dy,(Double)dx);
      px=dx*(r-r2)/r2;
      py=dy*(r-r2)/r2;
      rotx(PI*py/WinHeight);
      roty(PI*px/WinWidth);
      rotz(theta-theta2);
    }
  else
    {
      rotx(PI*(py-dy)/WinHeight);
      roty(PI*(px-dx)/WinWidth);
    }
  cur_flag=1;
  refresh();
  cur_flag=0;
  global_flag=gf;
  px=dx;
  py=dy;
}

SV_Function void StartMouse(Widget w,XtPointer closure,XtPointer dat)
{
  XEvent *ev;
  ev=(XEvent *)closure;
  px=(ev->xbutton.x)-WinWidthHalf;
  py=(ev->xbutton.y)-WinHeightHalf;
  cursor=XCreateFontCursor(disp,XC_fleur);
  XDefineCursor(disp,win,cursor);
}

SV_Function void StopMouse(Widget w,XtPointer closure,XtPointer dat)
{
  sprintf(fbuf,"setvmt %f %f %f %f %f %f %f %f %f %f %f\n",
	  VMT[0][0],VMT[0][1],VMT[0][2],
	  VMT[1][0],VMT[1][1],VMT[1][2],
	  VMT[2][0],VMT[2][1],VMT[2][2],
	  shift[0],shift[1]
	  );
  AppendCommandQueue(fbuf);
}

SV_Function void Plot(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("plot");
}

SV_LocalVariable S_AT *last_atom
     =NULL;
SV_LocalVariable Double last_point0[3],last_point[2];

SV_Function void SelAtom(Widget w,XtPointer closure,XtPointer dat)
{
  int dx,dy;
  S_AT *a;
  XEvent *ev;
  if (n_atom==0) return;
  ev=(XEvent *)closure;
  dx=(ev->xbutton.x)-WinWidthHalf;
  dy=(ev->xbutton.y)-WinHeightHalf;
  last_point0[0]=dx/WinScale;
  last_point0[1]=-dy/WinScale;
  last_point0[2]=1;
  a=getnear(dx,dy);
  if (a!=NULL) {
    sprintf(fbuf,"select #%d",a->num);
    AppendCommandQueue(fbuf);
    last_atom=a;
  } else {
    last_atom=NULL;
  }
}

SV_Function void SelMolecule(Widget w,XtPointer closure,XtPointer dat)
{
  int dx,dy;
  S_AT *a;
  XEvent *ev;
  if (n_atom==0) return;
  ev=(XEvent *)closure;
  dx=(ev->xbutton.x)-WinWidthHalf;
  dy=(ev->xbutton.y)-WinHeightHalf;
  last_point0[0]=dx/WinScale;
  last_point0[1]=-dy/WinScale;
  last_point0[2]=1;
  a=getnear(dx,dy);
  if (a!=NULL) {
    sprintf(fbuf,"select fragment #%d",a->num);
    AppendCommandQueue(fbuf);
    last_atom=a;
  } else {
    last_atom=NULL;
  }
}

SV_Function void MoveMouse(Widget w,XtPointer closure,XtPointer dat)
{
  int dx,dy;
  S_AT *a;
  XEvent *ev;
  if (n_atom==0) return;
  ev=(XEvent *)closure;
  cursor=XCreateFontCursor(disp,XC_pencil);
  XDefineCursor(disp,win,cursor);
  dx=(ev->xbutton.x)-WinWidthHalf;
  dy=(ev->xbutton.y)-WinHeightHalf;
  a=getnear(dx,dy);
  gcolor(32);
  if (last_point0[2]==1) {
    last_point0[2]=0;
  } else {
    grect(gline,last_point0[0],last_point0[1],last_point[0],last_point[1]);
  }
  last_point[0]=dx/WinScale;
  last_point[1]=-dy/WinScale;
  if ((last_point0[0]-last_point[0])*(last_point0[0]-last_point[0])+
      (last_point0[1]-last_point[1])*(last_point0[1]-last_point[1])
      <motion_detect) {
    last_point0[2]=1;
    return;
  }
  grect(gline,last_point0[0],last_point0[1],last_point[0],last_point[1]);
  if (last_atom!=NULL) {
    gline(stacktop->axy[0],stacktop->axy[1],
          last_atom->axy[0],last_atom->axy[1]);
  }
  last_atom=a;
  gline(stacktop->axy[0],stacktop->axy[1],
        last_atom->axy[0],last_atom->axy[1]);
  gcolor(0);
}

SV_Function void AtomMenu(Widget w,XtPointer closure,XtPointer dat)
{
  XEvent *ev;
  if (n_atom==0) return;
  ev=(XEvent *)closure;
  XUndefineCursor(disp,win);
  if (last_point0[2]==0) {
    int dx,dy;
    dx=MouseX()-30;
    dy=MouseY()-150;
    XtSetArg(arg[0],XtNx,dx);
    XtSetArg(arg[1],XtNy,dy);
    XtSetValues(atompanelroot,arg,2);
    sprintf(fbuf,"%-4s %-4s",orgAtom[stacktop->atm].name,
	    orgAtom[last_atom->atm].name);
    XtSetArg(arg[0],XtNlabel,fbuf);
    XtSetValues(atompanellabel2,arg,1);
    XtPopup(atompanelroot,XtGrabExclusive);
  } else {
/*    refresh();*/
  }
}

SV_Function void atommenupopdown(void)
{
  XtPopdown(atompanelroot);
  refresh();
}

SV_Function void AtomMenuPopdown(Widget w,XtPointer closure,XtPointer dat)
{
  atommenupopdown();
}

SV_Function void SelRectInside(Widget w,XtPointer closure,XtPointer dat)
{
  atommenupopdown();
  AppendCommandQueue("pop");
  sprintf(fbuf,"selectrectin %f %f %f %f",
	  last_point[0],last_point[1],last_point0[0],last_point0[1]);
  AppendCommandQueue(fbuf);
}

SV_Function void SelRectOutside(Widget w,XtPointer closure,XtPointer dat)
{
  atommenupopdown();
  AppendCommandQueue("pop");
  sprintf(fbuf,"selectrectout %f %f %f %f",
	  last_point[0],last_point[1],last_point0[0],last_point0[1]);
  AppendCommandQueue(fbuf);
}

SV_Function void AtomSel(Widget w,XtPointer closure,XtPointer dat)
{
  atommenupopdown();
  sprintf(fbuf,"select #%d",last_atom->num);
  AppendCommandQueue(fbuf);
}

SV_Function void AtomMakeBond(Widget w,XtPointer closure,XtPointer dat)
{
  atommenupopdown();
  sprintf(fbuf,"makebond #%d #%d",popstack()->num,last_atom->num);
  AppendCommandQueue(fbuf);
}

SV_Function void AtomDelBond(Widget w,XtPointer closure,XtPointer dat)
{
  atommenupopdown();
  sprintf(fbuf,"delbond #%d #%d",popstack()->num,last_atom->num);
  AppendCommandQueue(fbuf);
}

SV_Function void AtomResetBond(Widget w,XtPointer closure,XtPointer dat)
{
  atommenupopdown();
  sprintf(fbuf,"resetbond #%d #%d",last_atom->num,popstack()->num);
  AppendCommandQueue(fbuf);
}

SV_Function void AtomDup(Widget w,XtPointer closure,XtPointer dat)
{
  atommenupopdown();
  sprintf(fbuf,"dupatom #%d #%d",last_atom->num,popstack()->num);
  AppendCommandQueue(fbuf);
}

SV_Function void Expos(Widget w,XtPointer closure,XtPointer dat)
{
  refresh();
}

SV_Function void Refresh(Widget w,XtPointer closure,XtPointer dat)
{
/*
  int i;
  for (i=1;i<=n_atom;i++) {
    if ( ATOM[i].view_flag>0 ) ATOM[i].view_flag=COLOR_NORMAL;
  }
*/
  refresh();
}

SV_Function void Quit(Widget w,XtPointer closure,XtPointer dat)
{
  fclose(log_fp);
  exit(0);
}


SV_Function void ContStop(Widget w,XtPointer closure,XtPointer dat)
{
  contstop=-1;
  sprintf(fbuf,"setvmt %f %f %f %f %f %f %f %f %f\n",
	  VMT[0][0],VMT[0][1],VMT[0][2],
	  VMT[1][0],VMT[1][1],VMT[1][2],
	  VMT[2][0],VMT[2][1],VMT[2][2]);
  AppendCommandQueue(fbuf);
}


Float contstep;

SV_Function void RotContX(caddr_t x,XtIntervalId *id)
{
  if (contstop>0) contstop--; else if (contstop==0) rotx(contstep);
  if (contstop==0) rot_interval=
    XtAddTimeOut(50,(XtTimerCallbackProc)RotContX,NULL);
}

SV_Function void RotContY(caddr_t x,XtIntervalId *id)
{
  if (contstop>0) contstop--; else if (contstop==0) roty(contstep);
  if (contstop==0) rot_interval=
    XtAddTimeOut(50,(XtTimerCallbackProc)RotContY,NULL);
}

SV_Function void RotContZ(caddr_t x,XtIntervalId *id)
{
  if (contstop>0) contstop--; else if (contstop==0) rotz(contstep);
  if (contstop==0){
    rot_interval=XtAddTimeOut(50,(XtTimerCallbackProc)RotContZ,NULL);
  }
}

SV_Function void RotXp(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=rot_step*PI/180;
  rotx(contstep);
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)RotContX,NULL);
  contstop=1;
}

SV_Function void RotXm(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=-rot_step*PI/180;
  rotx(contstep);
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)RotContX,NULL);
  contstop=1;
}

SV_Function void RotYp(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=rot_step*PI/180;
  roty(contstep);
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)RotContY,NULL);
  contstop=1;
}

SV_Function void RotYm(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=-rot_step*PI/180;
  roty(contstep);
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)RotContY,NULL);
  contstop=1;
}

SV_Function void RotZp(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=rot_step*PI/180;
  rotz(contstep);
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)RotContZ,NULL);
  contstop=1;
}

SV_Function void RotZm(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=-rot_step*PI/180;
  rotz(contstep);
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)RotContZ,NULL);
  contstop=1;
}

SV_Function void RotXp1(Widget w,XtPointer closure,XtPointer dat)
{
  sprintf(fbuf,"x %f",rot_step);
  AppendCommandQueue(fbuf);
}

SV_Function void RotXm1(Widget w,XtPointer closure,XtPointer dat)
{
  sprintf(fbuf,"x %f",-rot_step);
  AppendCommandQueue(fbuf);
}

SV_Function void RotYp1(Widget w,XtPointer closure,XtPointer dat)
{
  sprintf(fbuf,"y %f",rot_step);
  AppendCommandQueue(fbuf);
}

SV_Function void RotYm1(Widget w,XtPointer closure,XtPointer dat)
{
  sprintf(fbuf,"y %f",-rot_step);
  AppendCommandQueue(fbuf);
}

SV_Function void RotZp1(Widget w,XtPointer closure,XtPointer dat)
{
  sprintf(fbuf,"z %f",rot_step);
  AppendCommandQueue(fbuf);
}

SV_Function void RotZm1(Widget w,XtPointer closure,XtPointer dat)
{
  sprintf(fbuf,"z %f",-rot_step);
  AppendCommandQueue(fbuf);
}

SV_Function void StepCont(Widget w,XtPointer closure,XtPointer dat)
{
  if (contstop>0) contstop--; else if (contstop==0) rot_step_set();
  if (contstop==0){
    rot_interval=XtAddTimeOut(50,(XtTimerCallbackProc)StepCont,NULL);
  }
}

SV_Function void AddStep1(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=1;
  rot_step+=contstep;
  if (rot_step>360 || rot_step<0) rot_step=0;
  RotStepSet();
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)StepCont,NULL);
  contstop=1;
}

SV_Function void SubStep1(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=-1;
  rot_step+=contstep;
  if (rot_step>360 || rot_step<0) rot_step=0;
  RotStepSet();
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)StepCont,NULL);
  contstop=1;
}

SV_Function void SetStep90(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("setrot a 90");
  RotStepSet();
}

SV_Function void SetStep1(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("setrot a 1");
  RotStepSet();
}

SV_Function void ScaleCont(Widget w,XtPointer closure,XtPointer dat)
{
  if (contstop>0) {
    contstop--;
  } else if (contstop==0) {
    cmd_c=1;
    cmd_num[0]=contstep;
    scale_view();
  }
  if (contstop==0){
    rot_interval=XtAddTimeOut(50,(XtTimerCallbackProc)ScaleCont,NULL);
  }
}

SV_Function void Scale09(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=cmd_num[0]=1.0/1.1;
  scale_view();
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)ScaleCont,NULL);
  contstop=1;
}

SV_Function void Scale11(Widget w,XtPointer closure,XtPointer dat)
{
  contstep=cmd_num[0]=1.1;
  scale_view();
  rot_interval=XtAddTimeOut(500,(XtTimerCallbackProc)ScaleCont,NULL);
  contstop=1;
}

SV_Function void BondLen(Widget w,XtPointer closure,XtPointer dat)
{
  if (global_flag & GLOBALFLAG_BONDLEN) {
    AppendCommandQueue("omit bl");
  } else {
    AppendCommandQueue("include bl");
  }
  XtSetArg(arg[0],XtNleftBitmap,
           (global_flag & GLOBALFLAG_BONDLEN)!=0 ? check_mark : None);
  XtSetValues(w,arg,1);
}

SV_Function void Cell(Widget w,XtPointer closure,XtPointer dat)
{
  cmd_c=1;
  if (global_flag & GLOBALFLAG_CELL) {
    AppendCommandQueue("omit cell");
  } else {
    AppendCommandQueue("include cell");
  }    
  XtSetArg(arg[0],XtNleftBitmap,
           (global_flag & GLOBALFLAG_CELL) ? check_mark : None);
  XtSetValues(w,arg,1);
}

SV_Function void Label(Widget w,XtPointer closure,XtPointer dat)
{
  if (global_flag & GLOBALFLAG_LABEL) {
    AppendCommandQueue("omit lb");
  } else {
    AppendCommandQueue("include lb");
  }
  XtSetArg(arg[0],XtNleftBitmap,
           (global_flag & GLOBALFLAG_LABEL) ? check_mark : None);
  XtSetValues(w,arg,1);
}

SV_Function void Macro(Widget w,XtPointer closure,XtPointer dat)
{
}

SV_Function void PopStack(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("pop");
/*
  if (NULL!=(cmd_atom[0]=popstack())){
    cmd_c=1;
    dispxyz();
  }
*/
}

SV_Function void StepKeyin(Widget w,XtPointer closure,XtPointer dat)
{
  char buf[20];
  sprintf(buf,"%f",rot_step);
  if (KeyInput("=== Input Scale ===",buf,buf,15)>0) {
    sprintf(fbuf,"setrot a %s",buf);
    AppendCommandQueue(fbuf);
  }
}

SV_Function void Panic(Widget w,XtPointer closure,XtPointer dat)
{
  AppendCommandQueue("panic");
}

SV_Function void Keyin(Widget w,XtPointer closure,XtPointer dat)
{
  String str;
  XtSetArg(arg[0], XtNstring, &str);
  XtGetValues( w, arg,1);
  AppendCommandQueue(str);
/*
  if (cmdin()<0) 
        Quit(w,closure,dat);
  ErrorPopdown();
*/
  XtSetArg(arg[0], XtNstring, NULL);
  XtSetValues( w, arg,1);
}


SV_Function void RotStepSet(void)
{
  int i;
  char a[30];
  static char n[]="XXYYZZ";
  static char s[]="+-+-+-";
  if (X11MODE){
    for(i=0;i<6;i++){
      sprintf(a,"Rot %c %c%d",n[i],s[i],(int)rot_step);
      XtSetArg(arg[0],XtNlabel,(XtArgVal)a);
/*      XtSetArg(arg[1],XtNwidth,120);*/
      XtSetValues(rotpanels[i],arg,2);
    }
  }
}

SV_Function S_AT *getnear(int x,int y)
{
  Double xx,yy,x0,y0,len,minlen;
  int i,num=0;
  minlen=10000;
  x0=(Double)x/WinScale;
  y0=(Double)y/WinScale;
  for (i=0;i<n_satom;i++)
    {
      xx=SAT[i].axy[0]-x0;
      yy=SAT[i].axy[1]+y0;
      len=xx*xx+yy*yy;
      if (len<minlen && (SAT[i].view_flag & FLAG_OMIT)==0) 
        {
          minlen=len;
          num=i;
        }
    }
/*  if (minlen>10) return NULL;*/
  return SAT+num;
}

SV_Function void XDispGraph(char *txt,int num)
{
  if (txt==NULL) {
    XtSetArg(arg[0],XtNlabel,
	   "                                                            ");
    XtSetValues(errorlabel,arg,1);
    return;
  }

  XClearWindow(disp,err_win);
  XDrawString(disp,err_win,gc_col[0],270,10,txt,strlen(txt));
  XDrawLine(disp,err_win,gc_col[0],50,0,50,15);
  XDrawLine(disp,err_win,gc_col[0],250,0,250,15);
  XDrawLine(disp,err_win,gc_col[0],50,7,50+num*2,7);
  XFlush(disp);
  while (XtAppPending(app_context)!=0) {
    XEvent ev;
    XtAppNextEvent(app_context,&ev);
    XtDispatchEvent(&ev);
  }
}

SV_Function void XUnsetWaitCursor(void)
{
  XUndefineCursor(disp,win0);
  if (cur_flag==0){
    XUndefineCursor(disp,win);
  }
  XFlush(disp);
}

SV_Function void XSetWaitCursor(void)
{
  cursor=XCreateFontCursor(disp,XC_watch);
  XDefineCursor(disp,win0,cursor);
  XFlush(disp);
}

SV_Function void Configure(Widget w,XtPointer closure,XtPointer dat)
{
  XEvent *ev;
  ev=(XEvent *)closure;
  WinWidth=ev->xconfigure.width;
  WinWidthHalf=WinWidth/2;
  WinHeight=ev->xconfigure.height;
  WinHeightHalf=WinHeight/2;
  WinScale=WinHeight>WinWidth?WinWidth/10:WinHeight/10;
}

SV_Function void xtFlush(void)
{
  XEvent ev;
  while(XtAppPending(app_context)) {
    XtAppNextEvent(app_context,&ev);
    XtDispatchEvent(&ev);
  };
}

