/*  X-toolkit/Athena-Widget Interface Module   "xtmain.c"    -*- C -*- */

/*
#S#
#
# This Program is part of SV (Shelx-output Viewer)
# Copyright (C) 1991-1998 Takashi Nemoto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details. (File "COPYING")
#
#    Note!: General Public Licence is copyrighted by the Free Software 
#           Foundation,  but this code is copyrighted by me.
#
#    Send bugs and comments to tnemoto@eels.kuicr.kyoto-u.ac.jp
#
#E#
*/

#define __xtmain_c__
#define __xtcalls_c_proc__
#define __cmninit_c_proc__
#define __message_c_proc__
#define __svx_c_proc__
#define __cmd_c_proc__
#define __resource_c_proc__
/* #define __bond_c_proc__ */
#define __shelplot_c_proc__

#include "def.h"
#ifdef Xt
#include "sv.xbm"
#include "circ.xbm"
#include <math.h>
#include <signal.h>

#define WinSize 640

SV_Variable char dir_name[256];
SV_Variable Pixmap check_mark;
/* SV_Variable Pixmap dummy_pix,stack_pix;*/
SV_Variable Widget wstack;
SV_Variable Window stack_pix;
SV_Variable char win2buf[MaxWin2Buf],errorbuf[MaxErrorBuf],editwinbuf[80];
SV_Variable Arg arg[10];
SV_Variable Widget toplevel,viewwin;
SV_Variable Widget wwin2;
SV_Variable int WinWidth,WinHeight,WinWidthHalf,WinHeightHalf;
SV_Variable Double WinScale;

SV_LocalVariable MENU_Button rot_key[]
={
  {"rotxp",(XtCallbackProc)RotXp},
  {"rotxm",(XtCallbackProc)RotXm},
  {"rotyp",(XtCallbackProc)RotYp},
  {"rotym",(XtCallbackProc)RotYm},
  {"rotzp",(XtCallbackProc)RotZp},
  {"rotzm",(XtCallbackProc)RotZm},
  {"scl09",(XtCallbackProc)Scale09},
  {"scl11",(XtCallbackProc)Scale11},
  {"deptp",(XtCallbackProc)DepthP1},
  {"deptm",(XtCallbackProc)DepthM1},
  {"stepp",(XtCallbackProc)AddStep1},
  {"stepm",(XtCallbackProc)SubStep1},
  {"stp90",(XtCallbackProc)SetStep90},
  {"step1",(XtCallbackProc)SetStep1},
  {"stpky",(XtCallbackProc)StepKeyin},
  {"close",(XtCallbackProc)RotPopdown},
};

SV_LocalVariable MENU_Button main_key[]
={
  {"filemenu",(XtCallbackProc)NULL},
  {"modemenu",(XtCallbackProc)NULL},
/*  {"extramenu",(XtCallbackProc)NULL},*/
  {"quit",(XtCallbackProc)Quit},
#ifdef PANIC
  {"panic",(XtCallbackProc)Panic},
#endif
};
SV_LocalVariable MENU_Button mode_key[]
={
  {"bondlengthflag",(XtCallbackProc)BondLen},
  {"cellflag",(XtCallbackProc)Cell},
  {"label",(XtCallbackProc)Label},
  {"line",(XtCallbackProc)NULL},
  {"rotpanel",(XtCallbackProc)RotPanel},
};
SV_LocalVariable MENU_Button file_key[]
={
  {"readfile",(XtCallbackProc)ReadFile},
  {"line",(XtCallbackProc)NULL},
  {"plot",(XtCallbackProc)Plot},
  {"line",(XtCallbackProc)NULL},
  {"ortep",(XtCallbackProc)OrtOut},
  {"ortep3",(XtCallbackProc)Ort3Out},
  {"charon",(XtCallbackProc)CharonOut},
  {"chemray",(XtCallbackProc)ChemRayOut},
  {"rasmol",(XtCallbackProc)RasMolOut},
  {"cavity",(XtCallbackProc)CavOut},
  {"csd",(XtCallbackProc)CsdOut},
  {"shelxl",(XtCallbackProc)ShelxOut},
  {"chemdraw",(XtCallbackProc)ChemDrawOut},
  {"mactempas",(XtCallbackProc)MacTEMpasOut},
  {"line",(XtCallbackProc)NULL},
  {"quit",(XtCallbackProc)Quit},
};

/* LocalVariable MENU_Button extra_key[]
={
};
*/

SV_LocalVariable MENU_Button stack_key[]
={
  {"omitatom",(XtCallbackProc)OmitAtom},
  {"popsel",(XtCallbackProc)PopStack},
  {"clearsel",(XtCallbackProc)ClearStack},
  {"restoresel",(XtCallbackProc)RestoreStack},
  {"displaysel",(XtCallbackProc)DispStack},
  {"selbondmake",(XtCallbackProc)MakeBond},
  {"selbonddel",(XtCallbackProc)DelBond},
  {"pairbondmake",(XtCallbackProc)MakeBondPair},
  {"pairbonddel",(XtCallbackProc)DelBondPair},
};

SV_LocalVariable MENU_Button atom_key[]
={
  {"label3",NULL},
  {"selectin",(XtCallbackProc)SelRectInside},
  {"selectout",(XtCallbackProc)SelRectOutside},
  {"label1",NULL},
  {"PAIR",NULL},
  {"select",(XtCallbackProc)AtomSel},
  {"makebond",(XtCallbackProc)AtomMakeBond},
  {"delbond",(XtCallbackProc)AtomDelBond},
  {"resetbond",(XtCallbackProc)AtomResetBond},
  {"dupatom",(XtCallbackProc)AtomDup},
  {"cancel",(XtCallbackProc)AtomMenuPopdown},
};

SV_Variable XtActionsRec actionTable[]
={
  {"rotpanel",(XtActionProc)RotPanel},
  {"rotxp",(XtActionProc)RotXp},
  {"rotxm",(XtActionProc)RotXm},
  {"rotyp",(XtActionProc)RotYp},
  {"rotym",(XtActionProc)RotYm},
  {"rotzp",(XtActionProc)RotZp},
  {"rotzm",(XtActionProc)RotZm},
  {"rotxp1",(XtActionProc)RotXp1},
  {"rotxm1",(XtActionProc)RotXm1},
  {"rotyp1",(XtActionProc)RotYp1},
  {"rotym1",(XtActionProc)RotYm1},
  {"rotzp1",(XtActionProc)RotZp1},
  {"rotzm1",(XtActionProc)RotZm1},
  {"scl09",(XtActionProc)Scale09},
  {"scl11",(XtActionProc)Scale11},
  {"deptp",(XtActionProc)DepthP1},
  {"deptm",(XtActionProc)DepthM1},
  {"stepp",(XtActionProc)AddStep1},
  {"stepm",(XtActionProc)SubStep1},
  {"stp90",(XtActionProc)SetStep90},
  {"step1",(XtActionProc)SetStep1},
  {"stpky",(XtActionProc)StepKeyin},
  {"close",(XtActionProc)RotPopdown},
  {"quit",(XtActionProc)Quit},
  {"panic",(XtActionProc)Panic},
  {"bondlengthflag",(XtActionProc)BondLen},
  {"cellflag",(XtActionProc)Cell},
  {"label",(XtActionProc)Label},
  {"readfile",(XtActionProc)ReadFile},
  {"popsel",(XtActionProc)PopStack},
  {"clerasel",(XtActionProc)ClearStack},
  {"restoresel",(XtActionProc)RestoreStack},
  {"displaysel",(XtActionProc)DispStack},
  {"selbondmake",(XtActionProc)MakeBond},
  {"selbonddel",(XtActionProc)DelBond},
  {"pairbondmake",(XtActionProc)MakeBondPair},
  {"pairbonddel",(XtActionProc)DelBondPair},
  {"omitatom",(XtActionProc)OmitAtom},
  {"rotmouse",(XtActionProc)RotMouse},
  {"contstop",(XtActionProc)ContStop},
  {"shiftmouse",(XtActionProc)ShiftMouse},
  {"selatom",(XtActionProc)SelAtom},
  {"selmolecule",(XtActionProc)SelMolecule},
  {"movemouse",(XtActionProc)MoveMouse},
  {"atomsel",(XtActionProc)AtomSel},
  {"atommenu",(XtActionProc)AtomMenu},
  {"atommenupopdown",(XtActionProc)AtomMenuPopdown},
  {"startmouse",(XtActionProc)StartMouse},
  {"stopmouse",(XtActionProc)StopMouse},
  {"refresh",(XtActionProc)Refresh},
  {"keyin",(XtActionProc)Keyin},
  {"dialogok",(XtActionProc)DialogOk},
  {"dialogcancel",(XtActionProc)DialogCancel},
  {"waitint",(XtActionProc)WaitInt},
  {"expose",(XtActionProc)Expos},
  {"configure",(XtActionProc)Configure},
};

SV_Variable Widget rootpanel;
SV_Variable Widget cmdwin,wwin4,cmdpanel_win;
SV_Variable Widget dialogwin,dialogroot,dialogok,dialogcancel;
SV_Variable Widget waitbox,waitroot,waitlabel0,waitlabel1,waitint;
SV_Variable Widget cmdpanels[XtNumber(main_key)];
SV_Variable Widget rotpanelroot,rotpanel,rotpanels[XtNumber(rot_key)];
SV_Variable Widget filepanelroot,filepanels[XtNumber(file_key)];
SV_Variable Widget modepanelroot,modepanels[XtNumber(mode_key)];
/* Variable Widget extrapanelroot,extrapanels[XtNumber(extra_key)]; */
SV_Variable Widget stackpanel,stackpanels[XtNumber(stack_key)];
SV_Variable Widget atompanelroot,atompanel,atompanels[XtNumber(atom_key)];
SV_Variable Widget atompanellabel2;
SV_Variable Widget filemenu;
SV_Variable Widget modemenu;

/* Variable Widget errorroot,errorbox,errorlabel0,errorlabel,errorok; */
SV_Variable Widget errorbox,errorlabel0,errorlabel;

SV_Variable GC gc,gc_col[33];
SV_Variable Font font[8];
SV_Variable XtAppContext app_context;
static XrmOptionDescRec options[]={
  {"-fn1","*.svDefaultFont",XrmoptionSepArg,(caddr_t) NULL},
  {"-fn2","*.svReverseFont",XrmoptionSepArg,(caddr_t) NULL},
};

SV_Variable SvData svdata;
static XtResource resources[]={
  {"svDefaultFont",XtCFont,XtRFont,sizeof(Font),
     XtOffset(SvDataPtr,defaultFont),XtRString,"6x10"},
  {"svReverseFont",XtCFont,XtRFont,sizeof(Font),
     XtOffset(SvDataPtr,reverseFont),XtRString,"6x10"},
};

SV_Function void xinit(int *argcp,char **argv)
{
  Display *di;
  X11MODE=0;
  di=XOpenDisplay(NULL);
  if (di!=NULL) {
    X11MODE=-1;
    XCloseDisplay(di);

    toplevel=XtAppInitialize(&app_context,"XShelv",options,XtNumber(options),
			  argcp,argv,fallback_res,NULL,0);
    XtSetLanguageProc(NULL, NULL, NULL);

#ifdef DEBUG
    {
      char *VClass[]={
	"Static Gray","Gray Scale",
	"Static Color","Pseudo Color",
	"Direct Color","True Color"};
      fprintf(stderr,"X Status\n");
      fprintf(stderr,"Vendor  :%s:\n",ServerVendor(disp));
      fprintf(stderr,"Version :%d.%d (%d):\n",ProtocolVersion(disp),
	      ProtocolRevision(disp),VendorRelease(disp));
      fprintf(stderr,"Visual  :%s (%d bpp)\n",
	      VClass[DefaultVisual(disp,0)->class],DefaultDepth(disp,0));
      fprintf(stderr,"ScreenSize : %dx%d:\n",
	      DisplayWidth(disp,screen),DisplayHeight(disp,screen));
    }
#endif
    XtGetApplicationResources(toplevel,&svdata,resources,
			      XtNumber(resources),NULL,0);
    if (strncmp(ServerVendor(disp),"X11/NeWS",8)==0 && 
	VendorRelease(disp)<3000) X11R3=1; else X11R3=0;
        /* SUN Open Windows Check */
  }
}

SV_LocalFunction int XERRHANDLER(Display *d,XErrorEvent *e)
{
  return 0;
}

SV_Function int main(int argc,char **argv) 
{
  int i;
  xinit(&argc,argv);
  signal(SIGFPE,SIG_IGN);
  CommonInitialize();
  PrintMess();
  ginit();
  if (!X11MODE) {
    int f;
    if (argc<2) {
      PutMessage1("Can not open/decode input file");
      Exit(1);
    }
    sprintf(fbuf,"svx %s",argv[1]);
    AppendCommandQueue(fbuf);
    refresh();
    for(;;) {
      f=ExecCommand();
      if (f==0) continue;
      if (f<0) break;
      fgets(fbuf,cBufSize,stdin);
    }
    ginit2();
    Exit(0);
  }
  MAX_LINE=100;

/* ignore Error */
  XSetErrorHandler(XERRHANDLER);

/* set icon */
  XtSetArg(arg[0], XtNiconPixmap,
	   XCreateBitmapFromData(disp,XtScreen(toplevel)->root, sv_bits,
				 sv_width, sv_height));
  XtSetArg(arg[1], XtNiconName,"ShelxView");
  XtSetValues(toplevel, arg, 2);

/* set check mark */
  check_mark = XCreateBitmapFromData(disp,DefaultRootWindow(disp),
         (char *) circ_bits, circ_width, circ_height);

/* Setup ActionTable */
  XtAppAddActions(app_context,actionTable,XtNumber(actionTable));

/* setup windows */
/* Sv root */
  rootpanel=XtCreateManagedWidget("root",formWidgetClass,toplevel,arg,0);
/* Sv level 1 */
  cmdpanel_win=XtCreateManagedWidget("maincmdpanel",boxWidgetClass,rootpanel,
				     NULL,0);

  viewwin=XtCreateManagedWidget("viewwin",labelWidgetClass,rootpanel,NULL,0);
  WinWidth=WinHeight=WinSize;
  WinWidthHalf=WinWidth/2;
  WinHeightHalf=WinHeight/2;
  WinScale=0.1*(WinWidth<WinHeight?WinWidth:WinHeight);

  XtSetArg(arg[0],XtNstring,(XtArgVal)win2buf);
  XtSetArg(arg[1],XtNlength,MaxWin2Buf);
  XtSetArg(arg[2],XtNeditType,XawtextEdit);
  XtSetArg(arg[3],XtNscrollVertical,XawtextScrollWhenNeeded);
  wwin2=XtCreateManagedWidget("listwin",asciiTextWidgetClass,rootpanel,
			      arg,4);
  /*
  dummy_pix = XCreateBitmapFromData(disp,DefaultRootWindow(disp),
         (char *) circ_bits, circ_width, circ_height);
  stack_pix=XCreatePixmap(disp,dummy_pix,220,130,DefaultDepth(disp,screen));
  
  XFillRectangle(disp,stack_pix,gc_col[7],0,0,199,129);
  XtSetArg(arg[0],XtNbitmap,stack_pix);
  */
  
  wwin4=XtCreateManagedWidget("stackmenu",menuButtonWidgetClass,
			      rootpanel,NULL,0);
  wstack=XtCreateManagedWidget("bondswin",labelWidgetClass,rootpanel,
			      NULL,0);

/* command panel */
  XtSetArg(arg[0],XtNstring,(XtArgVal)editwinbuf);
  XtSetArg(arg[1],XtNlength,80);
  XtSetArg(arg[2],XtNeditType,XawtextEdit);
  cmdwin=XtCreateManagedWidget("cmdwin",asciiTextWidgetClass,cmdpanel_win,
			      arg,3);
  for(i=0;i<XtNumber(main_key);i++){
    switch(i) {
    case 0:
    case 1:
/*    case 2:*/
      cmdpanels[i]=XtCreateManagedWidget(
	  main_key[i].name,menuButtonWidgetClass,cmdpanel_win,arg,0);
      break;
    default:
      cmdpanels[i]=XtCreateManagedWidget(
           main_key[i].name,commandWidgetClass,cmdpanel_win,arg,0);
      XtAddCallback(cmdpanels[i],XtNcallback,main_key[i].proc,NULL);
    };
  }
  
/* Stack Panel */
  stackpanel=XtCreatePopupShell("stackmenuroot",simpleMenuWidgetClass,
				rootpanel,NULL,0);
/* Atom Panel */
  atompanelroot=XtCreatePopupShell("atompanelroot",overrideShellWidgetClass,
	rootpanel,NULL,0);
  atompanel=XtCreateManagedWidget("atompanel",boxWidgetClass,atompanelroot,
				 NULL,0);
  for(i=0;i<XtNumber(atom_key);i++) {
    if (atom_key[i].proc==NULL) {
      atompanels[i]=XtCreateManagedWidget(atom_key[i].name,labelWidgetClass,
					  atompanel,arg,0);
      if (strcmp("PAIR",atom_key[i].name)==0) atompanellabel2=atompanels[i];
    } else {
      atompanels[i]=XtCreateManagedWidget(atom_key[i].name,
					  commandWidgetClass,atompanel,arg,0);
      XtAddCallback(atompanels[i],XtNcallback,atom_key[i].proc,NULL);
    }
  }
  errorbox=XtCreateManagedWidget("errorbox",boxWidgetClass,rootpanel,NULL,0);
  errorlabel0=XtCreateManagedWidget("errorlabel0",labelWidgetClass,
				    errorbox,arg,0);
  errorlabel=XtCreateManagedWidget("errorlabel",labelWidgetClass,
				    errorbox,arg,0);
/* Rotation Panel */
  rotpanelroot=XtCreatePopupShell("rotmenu",applicationShellWidgetClass,
			    rootpanel,NULL,0);
  rotpanel=XtCreateManagedWidget("rotpanel",boxWidgetClass,rotpanelroot,
				 NULL,0);

  for(i=0;i<XtNumber(rot_key);i++) {
    rotpanels[i]=XtCreateManagedWidget(rot_key[i].name,
				       commandWidgetClass,rotpanel,arg,0);
    XtAddCallback(rotpanels[i],XtNcallback,rot_key[i].proc,NULL);
  }
/* Mode Menu */
  modepanelroot=XtCreatePopupShell("modemenuroot",simpleMenuWidgetClass,
			    rootpanel,NULL,0);
  for(i=0;i<XtNumber(mode_key);i++){
    modepanels[i]=XtCreateManagedWidget(mode_key[i].name,
      mode_key[i].proc==NULL ? smeLineObjectClass:smeBSBObjectClass,
				       modepanelroot,arg,0);
    XtSetArg(arg[0],XtNleftBitmap,i==2 && ! X11R3 ?check_mark:None);
    XtSetValues(modepanels[i],arg,1);
    XtAddCallback(modepanels[i],XtNcallback,mode_key[i].proc,NULL);
  }
/* File Menu */
  filepanelroot=XtCreatePopupShell("filemenuroot",simpleMenuWidgetClass,
			    rootpanel,NULL,0);
  for(i=0;i<XtNumber(file_key);i++){
    filepanels[i]=XtCreateManagedWidget(file_key[i].name,
      file_key[i].proc==NULL ? smeLineObjectClass:smeBSBObjectClass,
				       filepanelroot,arg,0);
    XtAddCallback(filepanels[i],XtNcallback,file_key[i].proc,NULL);
  }
/* Extra Menu */
/*
  extrapanelroot=XtCreatePopupShell("extramenuroot",simpleMenuWidgetClass,
			    rootpanel,NULL,0);
  for(i=0;i<XtNumber(extra_key);i++){
    extrapanels[i]=XtCreateManagedWidget(extra_key[i].name,
      extra_key[i].proc==NULL ? smeLineObjectClass:smeBSBObjectClass,
				       extrapanelroot,arg,0);
    XtAddCallback(extrapanels[i],XtNcallback,extra_key[i].proc,NULL);
  }
*/
/* stack */  
  for(i=0;i<XtNumber(stack_key);i++){
    stackpanels[i]=XtCreateManagedWidget(stack_key[i].name,
    stack_key[i].proc==NULL ? smeLineObjectClass:smeBSBObjectClass,
					 stackpanel,arg,0);
    XtAddCallback(stackpanels[i],XtNcallback,stack_key[i].proc,NULL);
  }
  
  dialogroot=XtCreatePopupShell("dialogroot",transientShellWidgetClass,
			    rootpanel,NULL,0);
  XtSetArg(arg[0],XtNlabel,(XtArgVal)"====== Input Directory ======");
  XtSetArg(arg[1],XtNwidth,400);
  dialogwin=XtCreateManagedWidget("dialogwin",
				   dialogWidgetClass,dialogroot,arg,2);
  dialogok=XtCreateManagedWidget("dialogok",commandWidgetClass,
				 dialogwin,NULL,0);
  XtAddCallback(dialogok,XtNcallback,(XtCallbackProc)DialogOk,NULL);
  dialogcancel=XtCreateManagedWidget("dialogcancel",commandWidgetClass,
				     dialogwin,NULL,0);
  XtAddCallback(dialogcancel,XtNcallback,(XtCallbackProc)DialogCancel,NULL);

/*
  errorroot=XtCreatePopupShell("errorroot",applicationShellWidgetClass,
			       rootpanel,NULL,0);
  errorbox=XtCreateManagedWidget("errorbox",boxWidgetClass,errorroot,NULL,0);
  errorlabel0=XtCreateManagedWidget("errorlabel0",labelWidgetClass,errorbox,
				    NULL,0);
  errorlabel=XtCreateManagedWidget("errorlabel",labelWidgetClass,errorbox,
				   NULL,0);
  errorok=XtCreateManagedWidget("errorok",commandWidgetClass,errorbox,NULL,0);
  
  XtAddCallback(errorok,XtNcallback,(XtCallbackProc)Errorpopdown,NULL);
*/

  waitroot=XtCreatePopupShell("waitroot",transientShellWidgetClass,
			       rootpanel,NULL,0);
  waitbox=XtCreateManagedWidget("waitwin",boxWidgetClass,waitroot,NULL,0);
  waitlabel0=XtCreateManagedWidget("waitlabel0",labelWidgetClass,waitbox,
				    NULL,0);
  waitlabel1=XtCreateManagedWidget("waitlabel1",labelWidgetClass,waitbox,
				    NULL,0);
  waitint=XtCreateManagedWidget("waitint",commandWidgetClass,waitbox,NULL,0);

  XtAddCallback(waitint,XtNcallback,(XtCallbackProc)WaitInt,NULL);


  XtRealizeWidget(toplevel);

  XtSetKeyboardFocus(toplevel,cmdwin);
  XtSetKeyboardFocus(dialogwin,dialogwin);

  gcolor(0);

  XFlush(disp);


  if (svx(argv[1])<0) {
    PutMessage1("Can not open/decode input file");
  }

  for(;;){
    XEvent ev;
    XtAppNextEvent(app_context,&ev);
    XtDispatchEvent(&ev);
    if (ExecCommand()<0) break;
  }
/*   XtAppMainLoop(app_context);  */
  return 0;  
}

#endif



